'To do:
'Engine:
'Fix camera bug
'
'Game:
'
'Other:
'

'$DYNAMIC
DEFINT A-Z

TYPE WindowType
  WinType AS INTEGER
  WinIndex AS INTEGER
END TYPE

TYPE MenuType
  NumOptions AS INTEGER
  OptionsLayout AS INTEGER
  x0 AS INTEGER
  y0 AS INTEGER
  xs AS INTEGER
  ys AS INTEGER
  CursorPos AS INTEGER
END TYPE

TYPE FormType
  x0 AS INTEGER
  y0 AS INTEGER
  xs AS INTEGER
  ys AS INTEGER
END TYPE

TYPE ExitType
  ExitX AS INTEGER
  ExitY AS INTEGER
  ExitType AS INTEGER
END TYPE

TYPE TileDatType
  Solid AS INTEGER
END TYPE

TYPE SpriteType
  x AS INTEGER
  y AS INTEGER
  Frame AS INTEGER
END TYPE

TYPE EntityType
  S AS SpriteType
  Script AS INTEGER
END TYPE

TYPE SkillType
  SP AS INTEGER
END TYPE

TYPE PlayerSkillType
  SP AS INTEGER
END TYPE

DECLARE SUB CloseProgram ()
DECLARE SUB DrawSprite (x, y, SpriteArray(), Index)
DECLARE SUB GetInput ()
DECLARE SUB InitData ()
DECLARE SUB LoadMap (MapName$)
DECLARE SUB LoadPal ()
DECLARE SUB LoadTileset (TSIndex)
DECLARE SUB Render ()
DECLARE SUB SetMoveStatus (Status)
DECLARE SUB Update ()

DECLARE SUB CallScript (ScriptNum, EntIndex)
DECLARE SUB ExitMap (Ex AS ExitType, MapName$)
DECLARE SUB GotoMap (MapName$, x, y)
DECLARE SUB LoadGame (Slot)
DECLARE SUB Move (x, y)
DECLARE SUB SaveGame (Slot)
DECLARE FUNCTION Script (ScriptIndex, EntIndex)
DECLARE SUB ViewEntity (EntityIndex)

DECLARE SUB CloseWindow (WinType, WinIndex)
DECLARE SUB OpenWindow (WinType, WinIndex)

DECLARE SUB CloseMenu (Menu)
DECLARE SUB MenuBox (x0, y0, xs, ys)
DECLARE SUB MenuRender (Menu)
DECLARE SUB MenuSelect (SelectType)
DECLARE SUB OpenMenu (Menu)
DECLARE FUNCTION ToMenuX (Menu)
DECLARE FUNCTION ToMenuY (Menu)

DECLARE SUB CloseForm (Form)
DECLARE SUB FormRender (Form)
DECLARE SUB OpenForm (Form)

DECLARE SUB CloseTextBox ()
DECLARE SUB TextBox (Text$)

DECLARE SUB TextOut (Text$)
DECLARE SUB TxCRLF ()
DECLARE SUB TxLocate (x, y)

DECLARE SUB Battle (enemy, Boss)
DECLARE SUB BattleRender ()
DECLARE SUB BattleUpdate ()
DECLARE SUB CloseBattle ()
DECLARE FUNCTION RandBattle ()
DECLARE SUB SetBattleSteps ()

DECLARE SUB AddToInventory (Item)
DECLARE FUNCTION ExpForLevel& (Lev)
DECLARE SUB GetExp (ExpAm)
DECLARE SUB LearnSkill (skillindex)
DECLARE SUB LoseItem (Item)
DECLARE FUNCTION UseItem (Item)

DECLARE FUNCTION LoadStr$ (File, Length)
DECLARE SUB SaveStr (File, Dat$, Length)

CONST C.POS = 0
CONST C.ENTITY = 1

CONST M.PLAYER = 0
CONST M.MENU = 1
CONST M.FORM = 2
CONST M.TEXTBOX = 3

CONST E.ABS = 0
CONST E.REL = 1

CONST OL.HORIZONTAL = 0
CONST OL.VERTICAL = 1

CONST I.Heal = 0
CONST I.LgHeal = 1
CONST I.FullHeal = 2
CONST I.Revive = 3
CONST I.Restore = 4
CONST I.LgRestore = 5
CONST I.FullRestore = 6
CONST I.SkillsUp = 7
CONST I.DefensePill = 8

CONST S.Attack = 0
CONST S.Mirror = 1
CONST S.Double = 2
CONST S.Block = 3
CONST S.SummonGnome = 4

CONST ST.MinDamage = 0
CONST ST.MaxDamage = 1
CONST ST.NoDefense = 2
CONST ST.HPBoost = 3
CONST ST.DefenseUp = 4

CONST B.DemonGuard = 0
CONST B.DemonLord = 1
CONST B.DemonSlavedriver = 2
CONST B.DemonWarlord = 3
CONST B.DemonShadowlord = 4
CONST B.ArchDemon = 5

CONST F.DemonGuardDead = 0
CONST F.DemonLordDead = 1
CONST F.DemonSlavedriverDead = 2
CONST F.DemonWarlordDead = 3
CONST F.DemonShadowlordDead = 4
CONST NumFlags = 5

CONST KR.GAME = 90
CONST KR.MENU = 240

DIM SHARED Tileset(0) AS STRING, MaxTiles
DIM SHARED Tiles(0), ToTil(0), TileDat(0) AS TileDatType
DIM SHARED Sprites(0), BSprites(0), ToSpr(0), ToMsk(0)
DIM SHARED Entity(63) AS EntityType, NumEntitys, NumFixedEntitys
DIM SHARED EntOT(49, 49)
DIM SHARED NextX, NextY

DIM SHARED Map(49, 49), MapXSize, MapYSize, CurTileset
DIM SHARED MapBattles, BattleSteps, MapFileName$
DIM SHARED ExitX0Map$, ExitX1Map$, ExitY0Map$, ExitY1Map$
DIM SHARED ExitX0 AS ExitType, ExitX1 AS ExitType
DIM SHARED ExitY0 AS ExitType, ExitY1 AS ExitType

DIM SHARED InBattle, BattleOption, BattleDraw, BattleResult, BossBattle
DIM SHARED EnemyName$, EnemyHP AS LONG, EnemyMaxHP AS LONG, EnemyMaxDamage, EnemyMinDamage
DIM SHARED EnemyDefense, EnemyExp, EnemyFrame
DIM SHARED Status(4), NumStatuses

DIM SHARED HP, MaxHP, MinDamage, MaxDamage, Defense, MaxSP
DIM SHARED BaseMaxHP, BaseDefense
DIM SHARED Expr AS LONG, NextExp AS LONG, Level

DIM SHARED Skill(4) AS SkillType, SkillName(4) AS STRING, SkillDesc(4) AS STRING
DIM SHARED PlayerSkill(4) AS PlayerSkillType, NumPlayerSkills, CurSkill

DIM SHARED ItemName(8) AS STRING
DIM SHARED Inventory(9), NumInventorys, CurInventory

DIM SHARED Windows(31) AS WindowType, NumWindows

DIM SHARED Menu(31) AS MenuType, ShowMenu(31), NumShowMenus, CurMenu

DIM SHARED Form(31) AS FormType, ShowForm

DIM SHARED TextBoxText(15) AS STRING, NumTextBoxs, TextBoxOpen

DIM SHARED CurScript, ScriptStage, ScriptEnt
DIM SHARED Flag(NumFlags - 1)

DIM SHARED Font(17407)
DIM SHARED TxX, TxY, TxMarginX

DIM SHARED CamStatus, CamPX, CamPY

DIM SHARED MoveStatus

DIM SHARED QuitProgram, Refresh

RANDOMIZE TIMER

HP = 42: MaxHP = 42
MinDamage = 3: MaxDamage = 8: Defense = 0
MaxSP = 0
NextExp = ExpForLevel(1)

FOR z = 0 TO 4
  PlayerSkill(z).SP = MaxSP
NEXT

NumPlayerSkills = 1

InitData

CurScript = -1

Entity(0).S.x = 29 * 16
Entity(0).S.y = 28 * 16
Entity(0).S.Frame = 0

NumFixedEntitys = 1
NumEntitys = NumFixedEntitys

Menu(0).NumOptions = 3
Menu(0).OptionsLayout = OL.HORIZONTAL
Menu(0).x0 = -1
Menu(0).y0 = 104
Menu(0).xs = 160
Menu(0).ys = 16

Menu(1).NumOptions = 11
Menu(1).OptionsLayout = OL.VERTICAL
Menu(1).x0 = -1
Menu(1).y0 = 24
Menu(1).xs = 128
Menu(1).ys = 96

Menu(2).NumOptions = 5
Menu(2).OptionsLayout = OL.VERTICAL
Menu(2).x0 = 192
Menu(2).y0 = 48
Menu(2).xs = 72
Menu(2).ys = 48

Menu(3).NumOptions = 6
Menu(3).OptionsLayout = OL.VERTICAL
Menu(3).x0 = -1
Menu(3).y0 = 48
Menu(3).xs = 160
Menu(3).ys = 56

Menu(4).NumOptions = 3
Menu(4).OptionsLayout = OL.VERTICAL
Menu(4).x0 = -1
Menu(4).y0 = -1
Menu(4).xs = 96
Menu(4).ys = 32

Menu(5).NumOptions = 5
Menu(5).OptionsLayout = OL.VERTICAL
Menu(5).x0 = -1
Menu(5).y0 = -1
Menu(5).xs = 72
Menu(5).ys = 48

Menu(6).NumOptions = 5
Menu(6).OptionsLayout = OL.VERTICAL
Menu(6).x0 = -1
Menu(6).y0 = -1
Menu(6).xs = 72
Menu(6).ys = 48

Menu(7).NumOptions = 2
Menu(7).OptionsLayout = OL.VERTICAL
Menu(7).x0 = -1
Menu(7).y0 = -1
Menu(7).xs = 120
Menu(7).ys = 24

ShowForm = -1

Form(0).x0 = 152
Form(0).y0 = 32
Form(0).xs = 144
Form(0).ys = 56

SCREEN 13

LoadPal

ViewEntity 0

LoadMap "default"

IF (COMMAND$ = "-newgame") THEN
  CallScript 5, 0
ELSE
  LoadGame VAL(COMMAND$)
END IF

Refresh = -1

DO
  Update

  Render

  GetInput

LOOP UNTIL QuitProgram

CloseProgram

SCREEN 0: WIDTH 80

REM $STATIC
SUB AddToInventory (Item)

IF (NumInventorys = 10) THEN EXIT SUB

Inventory(NumInventorys) = Item

NumInventorys = NumInventorys + 1

TextBox "You found a " + ItemName(Item)

END SUB

SUB Battle (enemy, Boss)

IF (Boss) THEN
  SELECT CASE enemy
    CASE B.DemonGuard
      EnemyName$ = "Demon Guard"
      EnemyHP = 260
      EnemyMaxHP = 260
      EnemyMaxDamage = 23
      EnemyMinDamage = 9
      EnemyDefense = 12
      EnemyExp = 80
      EnemyFrame = 3

    CASE B.DemonLord
      EnemyName$ = "Demon Lord"
      EnemyHP = 1000
      EnemyMaxHP = 1000
      EnemyMaxDamage = 48
      EnemyMinDamage = 25
      EnemyDefense = 23
      EnemyExp = 220
      EnemyFrame = 7

    CASE B.DemonSlavedriver
      EnemyName$ = "Demon Slavedriver"
      EnemyHP = 2274
      EnemyMaxHP = 2274
      EnemyMaxDamage = 106
      EnemyMinDamage = 59
      EnemyDefense = 47
      EnemyExp = 470
      EnemyFrame = 11

    CASE B.DemonWarlord
      EnemyName$ = "Demon Warlord"
      EnemyHP = 9146
      EnemyMaxHP = 9146
      EnemyMaxDamage = 196
      EnemyMinDamage = 125
      EnemyDefense = 20
      EnemyExp = 950
      EnemyFrame = 15

    CASE B.DemonShadowlord
      EnemyName$ = "Demon Shadowlord"
      EnemyHP = 25656
      EnemyMaxHP = 25656
      EnemyMaxDamage = 283
      EnemyMinDamage = 212
      EnemyDefense = 81
      EnemyExp = 2500
      EnemyFrame = 19

    CASE B.ArchDemon
      EnemyName$ = "Arch-Demon"
      EnemyHP = 37762
      EnemyMaxHP = 37762
      EnemyMaxDamage = 460
      EnemyMinDamage = 300
      EnemyDefense = 111
      EnemyExp = 0
      EnemyFrame = 20

  END SELECT
ELSE
  EnemyFrame = MapBattles * 4 + enemy
  SELECT CASE MapBattles
    CASE 0
      SELECT CASE enemy
        CASE 0
          EnemyName$ = "Demon Spawn"
          EnemyHP = 26
          EnemyMaxHP = 26
          EnemyMaxDamage = 5
          EnemyMinDamage = 4
          EnemyDefense = 0
          EnemyExp = 2
        CASE 1
          EnemyName$ = "Lower Demon"
          EnemyHP = 39
          EnemyMaxHP = 39
          EnemyMaxDamage = 8
          EnemyMinDamage = 2
          EnemyDefense = 0
          EnemyExp = 4
        CASE 2
          EnemyName$ = "Demon Slave"
          EnemyHP = 52
          EnemyMaxHP = 52
          EnemyMaxDamage = 6
          EnemyMinDamage = 2
          EnemyDefense = 0
          EnemyExp = 3
      END SELECT

    CASE 1
      SELECT CASE enemy
        CASE 0
          EnemyName$ = "Pit Demon"
          EnemyHP = 122
          EnemyMaxHP = 122
          EnemyMaxDamage = 28
          EnemyMinDamage = 17
          EnemyDefense = 5
          EnemyExp = 6
        CASE 1
          EnemyName$ = "Demon Soldier"
          EnemyHP = 147
          EnemyMaxHP = 147
          EnemyMaxDamage = 33
          EnemyMinDamage = 21
          EnemyDefense = 12
          EnemyExp = 9
        CASE 2
          EnemyName$ = "Horned Demon"
          EnemyHP = 134
          EnemyMaxHP = 134
          EnemyMaxDamage = 38
          EnemyMinDamage = 17
          EnemyDefense = 2
          EnemyExp = 7
      END SELECT

    CASE 2
      SELECT CASE enemy
        CASE 0
          EnemyName$ = "Rune Demon"
          EnemyHP = 370
          EnemyMaxHP = 370
          EnemyMaxDamage = 69
          EnemyMinDamage = 60
          EnemyDefense = 22
          EnemyExp = 12
        CASE 1
          EnemyName$ = "Demon Berserker"
          EnemyHP = 396
          EnemyMaxHP = 396
          EnemyMaxDamage = 84
          EnemyMinDamage = 53
          EnemyDefense = 16
          EnemyExp = 13
        CASE 2
          EnemyName$ = "Demonic Slayer"
          EnemyHP = 480
          EnemyMaxHP = 480
          EnemyMaxDamage = 78
          EnemyMinDamage = 68
          EnemyDefense = 27
          EnemyExp = 19
      END SELECT

    CASE 3
      SELECT CASE enemy
        CASE 0
          EnemyName$ = "Demonic Demon"
          EnemyHP = 770
          EnemyMaxHP = 770
          EnemyMaxDamage = 97
          EnemyMinDamage = 72
          EnemyDefense = 31
          EnemyExp = 38
        CASE 1
          EnemyName$ = "Upper Demon"
          EnemyHP = 720
          EnemyMaxHP = 720
          EnemyMaxDamage = 88
          EnemyMinDamage = 81
          EnemyDefense = 37
          EnemyExp = 36
        CASE 2
          EnemyName$ = "Shadow Demon"
          EnemyHP = 820
          EnemyMaxHP = 820
          EnemyMaxDamage = 112
          EnemyMinDamage = 97
          EnemyDefense = 51
          EnemyExp = 49
      END SELECT

    CASE 4
      SELECT CASE enemy
        CASE 0
          EnemyName$ = "Demonic Destroyer"
          EnemyHP = 1780
          EnemyMaxHP = 1780
          EnemyMaxDamage = 167
          EnemyMinDamage = 142
          EnemyDefense = 66
          EnemyExp = 106
        CASE 1
          EnemyName$ = "Master Demon"
          EnemyHP = 1570
          EnemyMaxHP = 1570
          EnemyMaxDamage = 148
          EnemyMinDamage = 136
          EnemyDefense = 55
          EnemyExp = 82
        CASE 2
          EnemyName$ = "Archaic Demon"
          EnemyHP = 1430
          EnemyMaxHP = 1430
          EnemyMaxDamage = 165
          EnemyMinDamage = 125
          EnemyDefense = 47
          EnemyExp = 76
      END SELECT
  END SELECT
END IF

QB.KeyStop

OpenMenu 0

BattleOption = -1

BossBattle = Boss

InBattle = -1
BattleDraw = -1
BattleResult = 0

NumStatuses = 5
FOR z = 0 TO 4
  Status(z) = 0
NEXT

Refresh = -1

END SUB

SUB BattleRender

MenuBox -1, 32, 160, 72

TextOut EnemyName$

DrawSprite 80 - 8 + 40, 32 + 36, BSprites(), EnemyFrame
DrawSprite 80 + 160 - 8 - 40, 32 + 36, Sprites(), 10


MenuBox -1, 16, 160, 16

TextOut "HP:" + STR$(HP) + "/" + LTRIM$(STR$(MaxHP))

END SUB

SUB BattleUpdate

IF (BattleOption <> -1) THEN
  SELECT CASE BattleOption
    CASE 0:
      PlayerSkill(CurSkill).SP = PlayerSkill(CurSkill).SP - Skill(CurSkill).SP
      IF (Status(ST.MaxDamage)) THEN
        RndDmg = MaxDamage
      ELSE
        RndDmg = INT(RND * (MaxDamage - MinDamage + 1)) + MinDamage
      END IF
      IF (Status(ST.NoDefense)) THEN
        AmrDmg = RndDmg
      ELSE
        AmrDmg = RndDmg * 1 / (1 + EnemyDefense / 256)
      END IF
      SELECT CASE CurSkill
        CASE S.Attack: Dmg = AmrDmg
        CASE S.Mirror: Dmg = AmrDmg
        CASE S.Double: Dmg = AmrDmg * 2
        CASE S.Block: Dmg = AmrDmg
        CASE S.SummonGnome:
          IF (MaxDamage * 4 <= EnemyMaxHP) THEN
            IF (NumStatuses = 0) THEN N = 65 ELSE N = INT(RND * 100)
            SELECT CASE N
              CASE 0 TO 64
                S = INT(RND * NumStatuses)
                z = 0
                DO  'could be done using FOR but qb sucks...
                  IF (Status(z)) THEN S = S + 1
                  IF (z = S) THEN EXIT DO
                  z = z + 1
                LOOP
                Status(S) = -1
                NumStatuses = NumStatuses - 1
                SELECT CASE S
                  CASE ST.MinDamage: BattleText$ = BattleText$ + "Gnome gives MinDamage to enemy!" + CHR$(13)
                  CASE ST.MaxDamage: BattleText$ = BattleText$ + "Gnome gives MaxDamage!" + CHR$(13)
                  CASE ST.NoDefense: BattleText$ = BattleText$ + "Gnome gives NoDefense!" + CHR$(13)
                  CASE ST.HPBoost: BaseMaxHP = MaxHP: MaxHP = MaxHP * 1.15
                    HP = HP + (MaxHP - BaseMaxHP)
                    BattleText$ = BattleText$ + "The gnome increases your MaxHP!" + CHR$(13)
                  CASE ST.DefenseUp: BaseDefense = Defense: Defense = Defense * 1.2
                    BattleText$ = BattleText$ + "The gnome increases your defense!" + CHR$(13)
                END SELECT
            END SELECT
          END IF
      END SELECT
    CASE 1: IF (NOT UseItem(CurInventory)) THEN BattleOption = -1: EXIT SUB
    CASE 2: CloseBattle: EXIT SUB
    CASE 3:
      FOR z = 0 TO NumInventorys - 1
        IF (Inventory(z) = I.Revive) THEN EXIT FOR
      NEXT
      LoseItem z
      TextBox "Revive!"
      HP = MaxHP
      FOR z = 0 TO 4
        PlayerSkill(z).SP = MaxSP
      NEXT
  END SELECT

  IF (BattleOption <> 3) THEN
    IF (Status(ST.MinDamage)) THEN
      ERndDmg = EnemyMinDamage
    ELSE
      ERndDmg = INT(RND * (EnemyMaxDamage - EnemyMinDamage + 1)) + EnemyMinDamage
    END IF
    EAmrDmg = ERndDmg * 1 / (1 + Defense / 256)

    SELECT CASE BattleOption
      CASE 0
        SELECT CASE CurSkill
          CASE S.Attack: BattleText$ = BattleText$ + "You attack the enemy for" + STR$(Dmg) + " damage" + CHR$(13)
          CASE S.Mirror
            IF (Dmg <= EAmrDmg) THEN
              BattleText$ = BattleText$ + "Mirror!" + CHR$(13)
              Dmg = EAmrDmg
            ELSE
              BattleText$ = BattleText$ + "The enemy's attack was too weak." + CHR$(13)
            END IF
            BattleText$ = BattleText$ + "You attack the enemy for" + STR$(Dmg) + " damage" + CHR$(13)
          CASE S.Double: BattleText$ = BattleText$ + "Double Damage!" + CHR$(13)
            BattleText$ = BattleText$ + "You attack the enemy for" + STR$(Dmg) + " damage" + CHR$(13)
          CASE S.Block:
            BattleText$ = BattleText$ + "You attack the enemy for" + STR$(Dmg) + " damage" + CHR$(13)
            BattleText$ = BattleText$ + "You blocked the attack!" + CHR$(13)
            EAmrDmg = 0
          CASE S.SummonGnome
            IF (MaxDamage * 4 > EnemyMaxHP) THEN
              BattleText$ = BattleText$ + "The gnome killed the enemy!" + CHR$(13)
              Dmg = EnemyHP
              EAmrDmg = 0
            ELSE
              SELECT CASE N
                CASE 65 TO 99: Dmg = 4 * MaxDamage
                BattleText$ = BattleText$ + "The gnome does" + STR$(Dmg) + " damage!" + CHR$(13)
              END SELECT
            END IF
        END SELECT
    END SELECT

    HP = HP - EAmrDmg
    EnemyHP = EnemyHP - Dmg

    BattleText$ = BattleText$ + "The enemy attacks for" + STR$(EAmrDmg) + " damage"

    TextBox BattleText$

    IF (HP <= 0) THEN
      FOR z = 0 TO NumInventorys - 1
        IF (Inventory(z) = I.Revive) THEN EXIT FOR
      NEXT
      IF (z = NumInventorys) THEN
        BattleResult = 2
        CloseBattle
        CallScript 6, 0
        EXIT SUB
      ELSE
        HP = 0
        BattleOption = -1
        QB.KeyStop
        OpenMenu 7
        EXIT SUB
      END IF
    END IF
  END IF
  IF (EnemyHP <= 0) THEN
    BattleResult = 1
    CloseBattle
    TextBox "You defeated the enemy!" + CHR$(13) + "Gained" + STR$(EnemyExp) + " exp"
    GetExp EnemyExp
    IF (NOT BossBattle) THEN
      N = INT(RND * 100)
      SELECT CASE MapBattles
        CASE 0
          SELECT CASE N
            CASE IS < 35: AddToInventory I.Heal
            CASE IS < 39: AddToInventory I.LgHeal
            CASE IS < 41: AddToInventory I.DefensePill
          END SELECT

        CASE 1
          SELECT CASE N
            CASE IS < 10: AddToInventory I.Heal
            CASE IS < 45: AddToInventory I.LgHeal
            CASE IS < 48: AddToInventory I.SkillsUp
            CASE IS < 51: AddToInventory I.Restore
            CASE IS < 53: AddToInventory I.DefensePill
          END SELECT

        CASE 2
          SELECT CASE N
            CASE IS < 30: AddToInventory I.LgHeal
            CASE IS < 45: AddToInventory I.FullHeal
            CASE IS < 50: AddToInventory I.Restore
            CASE IS < 62: AddToInventory I.LgRestore
            CASE IS < 64: AddToInventory I.Revive
            CASE IS < 67: AddToInventory I.SkillsUp
            CASE IS < 69: AddToInventory I.DefensePill
          END SELECT

        CASE 3
          SELECT CASE N
            CASE IS < 37: AddToInventory I.FullHeal
            CASE IS < 43: AddToInventory I.Revive
            CASE IS < 48: AddToInventory I.LgRestore
            CASE IS < 51: AddToInventory I.FullRestore
            CASE IS < 54: AddToInventory I.SkillsUp
            CASE IS < 56: AddToInventory I.DefensePill
          END SELECT

        CASE 4
          SELECT CASE N
            CASE IS < 25: AddToInventory I.FullHeal
            CASE IS < 45: AddToInventory I.Revive
            CASE IS < 55: AddToInventory I.FullRestore
            CASE IS < 60: AddToInventory I.SkillsUp
            CASE IS < 62: AddToInventory I.DefensePill
          END SELECT
      END SELECT
    END IF
  END IF

  BattleOption = -1
END IF

END SUB

SUB CallScript (ScriptNum, EntIndex)

CurScript = ScriptNum
ScriptEnt = EntIndex
ScriptStage = 0

END SUB

SUB CloseBattle

IF (Status(ST.HPBoost)) THEN
  MaxHP = BaseMaxHP
  IF (HP > MaxHP) THEN HP = MaxHP
END IF
IF (Status(ST.DefenseUp)) THEN Defense = BaseDefense

FOR z = 0 TO 4
  PlayerSkill(z).SP = MaxSP
NEXT

InBattle = 0

CloseMenu 0

IF (NOT TextBoxOpen) THEN BattleDraw = 0

END SUB

SUB CloseForm (Form)

SetMoveStatus M.PLAYER

CloseWindow M.FORM, Form

ShowForm = -1

Refresh = -1

END SUB

SUB CloseMenu (Menu)

NumShowMenus = NumShowMenus - 1

IF (NumShowMenus <> 0) THEN CurMenu = ShowMenu(NumShowMenus - 1)

CloseWindow M.MENU, Menu

Refresh = -1

END SUB

SUB CloseProgram

DEF SEG

END SUB

SUB CloseTextBox

NumTextBoxs = NumTextBoxs - 1

FOR z = 0 TO NumTextBoxs - 1
  TextBoxText(z) = TextBoxText(z + 1)
NEXT

IF (NumTextBoxs = 0) THEN
  CloseWindow M.TEXTBOX, 0
  TextBoxOpen = 0
  IF (BattleDraw AND NOT InBattle) THEN BattleDraw = 0
END IF

Refresh = -1

END SUB

SUB CloseWindow (WinType, WinIndex)

FOR z = 0 TO NumWindows - 1
  IF (Windows(z).WinType = WinType AND Windows(z).WinIndex = WinIndex) THEN EXIT FOR
NEXT

NumWindows = NumWindows - 1

FOR z = z TO NumWindows - 1
  Windows(z) = Windows(z + 1)
NEXT

IF (NumWindows = 0) THEN
  SetMoveStatus M.PLAYER
ELSE
  SetMoveStatus Windows(NumWindows - 1).WinType
END IF

END SUB

SUB DrawSprite (x, y, SpriteArray(), Index)

PUT (x, y), SpriteArray(ToMsk(Index)), AND
PUT (x, y), SpriteArray(ToSpr(Index)), OR

END SUB

SUB ExitMap (Ex AS ExitType, MapName$)

SELECT CASE Ex.ExitType
  CASE E.ABS:
    Entity(0).S.x = Ex.ExitX * 16
    Entity(0).S.y = Ex.ExitY * 16
  CASE E.REL:
    Entity(0).S.x = Entity(0).S.x + Ex.ExitX * 16
    Entity(0).S.y = Entity(0).S.y + Ex.ExitY * 16
END SELECT

LoadMap MapName$

END SUB

FUNCTION ExpForLevel& (Lev)

FOR z = 1 TO Lev
  SELECT CASE z
    CASE 1: d = 11
    CASE 2: d = 27
    CASE 3: d = 48
    CASE 4: d = 67
    CASE 5: d = 95
    CASE 6: d = 132
    CASE 7: d = 157
    CASE 8: d = 189
    CASE 9: d = 204
    CASE 10: d = 256
    CASE 11: d = 326
    CASE 12: d = 384
    CASE 13: d = 460
    CASE 14: d = 550
    CASE 15: d = 666
    CASE 16: d = 824
    CASE 17: d = 1031
    CASE 18: d = 1000 + (Lev - 17) * Lev * 10
  END SELECT
  E& = E& + d
NEXT

ExpForLevel = E&

END FUNCTION

SUB FormRender (Form)

MenuBox Form(Form).x0, Form(Form).y0, Form(Form).xs, Form(Form).ys

SELECT CASE Form
  CASE 0:
    TextOut "Level:" + STR$(Level): TxCRLF
    TextOut "Exp:" + STR$(Expr) + "/" + LTRIM$(STR$(NextExp)): TxCRLF
    TxCRLF
    TextOut "HP:" + STR$(HP) + "/" + LTRIM$(STR$(MaxHP)): TxCRLF
    TextOut "Damage:" + STR$(MinDamage) + "-" + LTRIM$(STR$(MaxDamage)): TxCRLF
    TextOut "Defense:" + STR$(Defense): TxCRLF

END SELECT

END SUB

SUB GetExp (ExpAm)

Expr = Expr + ExpAm

OldMaxHP = MaxHP
OldMaxDamage = MaxDamage
OldMinDamage = MinDamage
OldDefense = Defense

DO UNTIL Expr < ExpForLevel(Level + 1)

  GainedLevel = -1

  Level = Level + 1

  MinInc = 5 * (Level + 1): MaxInc = 10 * (Level + 1)
  MaxHP = MaxHP + INT(RND * (MaxInc - MinInc + 1)) + MinInc
  Dmg = INT(RND * (6 - 3 + 1)) + 3
  MaxDamage = MaxDamage + Dmg
  MinDamage = MinDamage + INT(RND * (Dmg - 3 + 1)) + 3
  Defense = Defense + INT(RND * (9 - 4 + 1)) + 4
  MaxSP = MaxSP + INT(RND * (12 - 5 + 1)) + 5

LOOP

IF (GainedLevel) THEN
  HP = HP + MaxHP - OldMaxHP

  NextExp = ExpForLevel(Level + 1)
  LevelText$ = "You are now on level:" + STR$(Level) + CHR$(13)
  LevelText$ = LevelText$ + "MaxHP +" + LTRIM$(STR$(MaxHP - OldMaxHP)) + CHR$(13)
  LevelText$ = LevelText$ + "Damage +" + LTRIM$(STR$(MinDamage - OldMinDamage)) + "-+" + LTRIM$(STR$(MaxDamage - OldMaxDamage)) + CHR$(13)
  LevelText$ = LevelText$ + "Defense +" + LTRIM$(STR$(Defense - OldDefense))
  TextBox LevelText$

  FOR z = 0 TO 4
    PlayerSkill(z).SP = MaxSP
  NEXT
END IF

END SUB

SUB GetInput

DO
  GotInput = -1

  SELECT CASE INKEY$
    CASE CHR$(0) + "K": Move -1, 0
    CASE CHR$(0) + "M": Move 1, 0
    CASE CHR$(0) + "H": Move 0, -1
    CASE CHR$(0) + "P": Move 0, 1

    CASE CHR$(13)
      SELECT CASE MoveStatus
        CASE M.PLAYER:
          FOR z = NumFixedEntitys TO NumEntitys - 1
            IF (Entity(z).S.Frame <> -1 AND Entity(z).S.x = NextX AND Entity(z).S.y = NextY) THEN
              CurScript = Entity(z).Script
              ScriptEnt = z
              ScriptStage = 0
              EXIT FOR
            END IF
          NEXT
          IF (z = NumEntitys) THEN OpenMenu 2
        CASE M.MENU: MenuSelect 0
        CASE M.FORM: CloseForm ShowForm
        CASE M.TEXTBOX: CloseTextBox
      END SELECT

    CASE CHR$(0) + "S":
      SELECT CASE MoveStatus
        CASE M.MENU: MenuSelect 1
      END SELECT

    CASE CHR$(27): QuitProgram = -1

    CASE ELSE: GotInput = 0
  END SELECT

LOOP UNTIL (GotInput OR QuitProgram)

END SUB

SUB GotoMap (MapName$, x, y)

Entity(0).S.x = x * 16
Entity(0).S.y = y * 16
LoadMap MapName$

END SUB

SUB InitData

OPEN "tiles.dat" FOR INPUT AS #1

DO
  LINE INPUT #1, N$
  NumTilesets = NumTilesets + 1
LOOP UNTIL EOF(1)

SEEK #1, 1
REDIM Tileset(NumTilesets - 1)
FOR z = 0 TO NumTilesets - 1
  LINE INPUT #1, Tileset(z)
NEXT

CLOSE #1

CurTileset = -1

OPEN "sprites.dat" FOR BINARY AS #1
NumSprites = (LOF(1) - 7) \ 260
CLOSE #1
REDIM Sprites(NumSprites * 130 - 1)
DEF SEG = VARSEG(Sprites(0))
BLOAD "sprites.dat", 0

MaxSprites = NumSprites

OPEN "bsprites.dat" FOR BINARY AS #1
NumSprites = (LOF(1) - 7) \ 260
CLOSE #1
REDIM BSprites(NumSprites * 130 - 1)
DEF SEG = VARSEG(BSprites(0))
BLOAD "bsprites.dat", 0

IF (NumSprites > MaxSprites) THEN MaxSprites = NumSprites

REDIM ToSpr(MaxSprites - 1)
REDIM ToMsk(MaxSprites - 1)
FOR z = 0 TO MaxSprites - 1
  ToSpr(z) = z * 130 * 2
  ToMsk(z) = z * 130 * 2 + 130
NEXT

DEF SEG = VARSEG(Font(0))
BLOAD "font.dat", 0


SkillName(S.Attack) = "Attack"
Skill(S.Attack).SP = 0
SkillName(S.Mirror) = "Mirror"
Skill(S.Mirror).SP = 11
SkillName(S.Double) = "Double"
Skill(S.Double).SP = 32
SkillName(S.Block) = "Block"
Skill(S.Block).SP = 57
SkillName(S.SummonGnome) = "Summon Gnome"
Skill(S.SummonGnome).SP = 64

SkillDesc(S.Attack) = "Standard attack."
SkillDesc(S.Mirror) = "Do the same or more damage back to" + CHR$(13) + "the enemy."
SkillDesc(S.Double) = "Do double your normal attack" + CHR$(13) + "damage."
SkillDesc(S.Block) = "Attack, then block the enemy."
SkillDesc(S.SummonGnome) = "Who knows what the gardengnome will" + CHR$(13) + "do?"

ItemName(I.Heal) = "Heal"
ItemName(I.LgHeal) = "Lg. Heal"
ItemName(I.FullHeal) = "Full Heal"
ItemName(I.Revive) = "Revive"
ItemName(I.Restore) = "Restore"
ItemName(I.LgRestore) = "Lg. Restore"
ItemName(I.FullRestore) = "Full Restore"
ItemName(I.SkillsUp) = "SkillsUp"
ItemName(I.DefensePill) = "Defense Pill"

END SUB

SUB LearnSkill (skillindex)

NumPlayerSkills = skillindex + 1

TextBox "Learned new skill: " + SkillName$(skillindex)

END SUB

SUB LoadGame (Slot)

SaveFileName$ = "save" + LTRIM$(STR$(Slot)) + ".sav"

SaveFile = FREEFILE
OPEN SaveFileName$ FOR BINARY AS SaveFile

GET SaveFile, , HP
GET SaveFile, , MaxHP
GET SaveFile, , MaxDamage
GET SaveFile, , MinDamage
GET SaveFile, , Defense
GET SaveFile, , NumPlayerSkills
GET SaveFile, , Level
GET SaveFile, , Expr
GET SaveFile, , MaxSP

GET SaveFile, , NumInventorys
FOR z = 0 TO NumInventorys - 1
  GET SaveFile, , Inventory(z)
NEXT

NextExp = ExpForLevel(Level + 1)

FOR z = 0 TO NumFlags - 1
  GET SaveFile, , Flag(z)
NEXT

CLOSE SaveFile

FOR z = 0 TO 4
  PlayerSkill(z).SP = MaxSP
NEXT

END SUB

SUB LoadMap (MapName$)

FOR y = 0 TO 49
  FOR x = 0 TO 49
    EntOT(x, y) = -1
  NEXT
NEXT

MapFileName$ = MapName$

MapFile = FREEFILE

OPEN "Data\" + MapName$ + ".map" FOR BINARY AS MapFile

GET MapFile, , MapXSize
GET MapFile, , MapYSize
GET MapFile, , MapTileset

LoadTileset MapTileset

GET MapFile, , ExitX0
ExitX0Map$ = LoadStr(MapFile, 8)
GET MapFile, , ExitX1
ExitX1Map$ = LoadStr(MapFile, 8)
GET MapFile, , ExitY0
ExitY0Map$ = LoadStr(MapFile, 8)
GET MapFile, , ExitY1
ExitY1Map$ = LoadStr(MapFile, 8)

GET MapFile, , MapBattles

FOR y = 0 TO 49
  FOR x = 0 TO 49
    GET MapFile, , Map(x, y)
  NEXT
NEXT

GET MapFile, , NumScripts

NumEntitys = NumFixedEntitys + NumScripts

FOR z = 0 TO NumScripts - 1
  GET MapFile, , Entity(z + NumFixedEntitys)
NEXT

CLOSE MapFile

' Ack, lame hard-coding !!!
SELECT CASE MapFileName$
  CASE "dshrine"
    IF (Flag(F.DemonGuardDead)) THEN Entity(NumFixedEntitys).S.Frame = -1
  CASE "dwrld0"
    IF (Flag(F.DemonLordDead)) THEN Entity(NumFixedEntitys).S.Frame = -1
  CASE "dwrld1"
    IF (Flag(F.DemonSlavedriverDead)) THEN Entity(NumFixedEntitys).S.Frame = -1
  CASE "dwrld2"
    IF (Flag(F.DemonWarlordDead)) THEN Entity(NumFixedEntitys).S.Frame = -1
  CASE "dwrld3"
    IF (Flag(F.DemonShadowlordDead)) THEN Entity(NumFixedEntitys).S.Frame = -1
END SELECT

SetBattleSteps

END SUB

SUB LoadPal

OPEN "pal.dat" FOR BINARY AS #1
OUT &H3C8, 0
C$ = " "
FOR z = 0 TO 767
  GET #1, , C$
  OUT &H3C9, ASC(C$)
NEXT
CLOSE #1

END SUB

FUNCTION LoadStr$ (File, Length)

Dat$ = SPACE$(Length)
GET #1, , Dat$

LoadStr = RTRIM$(Dat$)

END FUNCTION

SUB LoadTileset (TSIndex)

IF (CurTileset = TSIndex) THEN EXIT SUB

CurTileset = TSIndex

TileFile = FREEFILE

OPEN "Data\" + Tileset(TSIndex) + ".dat" FOR BINARY AS TileFile
NumTiles = (LOF(TileFile) - 7) / 260
CLOSE TileFile

IF (NumTiles > MaxTiles) THEN
  MaxTiles = NumTiles
  REDIM Tiles(NumTiles * 130 - 1)
  REDIM ToTil(NumTiles - 1)
  FOR z = 0 TO NumTiles - 1
    ToTil(z) = z * 130
  NEXT
  REDIM TileDat(NumTiles - 1)
END IF

DEF SEG = VARSEG(Tiles(0))
BLOAD "Data\" + Tileset(TSIndex) + ".dat", 0

DEF SEG = VARSEG(TileDat(0))
BLOAD "Data\" + Tileset(TSIndex) + ".tdt", 0

END SUB

SUB LoseItem (Item)

NumInventorys = NumInventorys - 1
FOR z = Item TO NumInventorys - 1
  Inventory(z) = Inventory(z + 1)
NEXT

END SUB

SUB MenuBox (px0, py0, xs, ys)

IF (px0 = -1) THEN
  x0 = 160 - xs \ 2
ELSE
  x0 = px0
END IF
IF (py0 = -1) THEN
  y0 = 100 - ys \ 2
ELSE
  y0 = py0
END IF

x1 = x0 + xs - 1
y1 = y0 + ys - 1

LINE (x0, y0)-(x1, y1), 53, B
LINE (x0 + 1, y1)-(x1, y1), 52
LINE (x1, y0 + 1)-(x1, y1 - 1), 52

LINE (x0 + 1, y0 + 1)-(x1 - 1, y1 - 1), 53, B
LINE (x0 + 1, y0 + 1)-(x1 - 2, y0 + 1), 52
LINE (x0 + 1, y0 + 2)-(x0 + 1, y1 - 2), 52

LINE (x0 + 2, y0 + 2)-(x1 - 2, y1 - 2), 17, BF

TxLocate x0 + 4, y0 + 4

END SUB

SUB MenuRender (Menu)

DIM Options(20) AS STRING

MenuBox Menu(Menu).x0, Menu(Menu).y0, Menu(Menu).xs, Menu(Menu).ys

SELECT CASE Menu
  CASE 0
    IF (NumPlayerSkills < 2) THEN
      Options(0) = "Attack"
    ELSE
      Options(0) = "Skill"
    END IF
    Options(1) = "Item"
    Options(2) = "Run"

  CASE 1
    Options(0) = "Cancel"
    FOR z = 0 TO NumInventorys - 1
      Options(z + 1) = ItemName(Inventory(z))
    NEXT

  CASE 2
    Options(0) = "Stats"
    Options(1) = "Skills"
    Options(2) = "Item"
    Options(3) = "Return"
    Options(4) = "Quit"

  CASE 3
    Options(0) = "Cancel"
    FOR z = 0 TO NumPlayerSkills - 1
      IF (Skill(z).SP = 0) THEN
        Amnt = 99
      ELSE
        Amnt = PlayerSkill(z).SP \ Skill(z).SP
        IF (Amnt > 99) THEN Amnt = 99
      END IF
      AmntStr$ = LTRIM$(STR$(Amnt))
      Options(z + 1) = SPACE$(16)
      MID$(Options(z + 1), 1) = SkillName(z)
      MID$(Options(z + 1), 17 - LEN(AmntStr$)) = AmntStr$
    NEXT

  CASE 4
    Options(0) = "New Game"
    Options(1) = "Load Game"
    Options(2) = "Quit"

  CASE 5, 6
    Options(0) = "Cancel"
    FOR z = 0 TO 3
      Options(z + 1) = "Slot" + STR$(z)
    NEXT

  CASE 7
    Options(0) = "Use Revive"
    Options(1) = "Don't Revive"

END SELECT

SELECT CASE Menu(Menu).OptionsLayout
  CASE OL.HORIZONTAL
    FOR z = 0 TO Menu(Menu).NumOptions - 1
      IF (z = Menu(Menu).CursorPos) THEN TextOut (">") ELSE TextOut (" ")
      TextOut Options(z) + " "
    NEXT

  CASE OL.VERTICAL
    FOR z = 0 TO Menu(Menu).NumOptions - 1
      IF (z = Menu(Menu).CursorPos) THEN TextOut ("> ") ELSE TextOut ("  ")
      TextOut Options(z)
      TxCRLF
    NEXT
END SELECT

END SUB

SUB MenuSelect (SelectType)

CurOption = Menu(CurMenu).CursorPos

SELECT CASE CurMenu
  CASE 0
    SELECT CASE CurOption
      CASE 0
        FOR z = NumPlayerSkills - 1 TO 1 STEP -1
          IF (PlayerSkill(z).SP >= Skill(z).SP) THEN EXIT FOR
        NEXT
        IF (z = 0) THEN
          BattleOption = 0
          CurSkill = 0
        ELSE
          OpenMenu 3
          Menu(3).CursorPos = z + 1
        END IF
      CASE 1: IF (NumInventorys) THEN OpenMenu 1
      CASE 2: BattleOption = 2
    END SELECT

  CASE 1
    SELECT CASE SelectType
      CASE 0
        IF (CurOption = 0) THEN
          CloseMenu 1
        ELSE
          IF (CurOption - 1 < NumInventorys) THEN
            CurInventory = CurOption - 1
            IF (InBattle) THEN BattleOption = 1 ELSE N = UseItem(CurInventory)
            CloseMenu 1
          END IF
        END IF

      CASE 1: IF (CurOption <> 0 AND CurOption <= NumInventorys) THEN LoseItem CurOption - 1
    END SELECT

  CASE 2
    SELECT CASE CurOption
      CASE 0: OpenForm 0
      CASE 1: OpenMenu 3
      CASE 2: IF (NumInventorys) THEN OpenMenu 1
      CASE 3: CloseMenu 2
      CASE 4: QuitProgram = -1
    END SELECT

  CASE 3
    IF (CurOption = 0) THEN
      CloseMenu 3
    ELSE
      IF (CurOption - 1 < NumPlayerSkills) THEN
        CurSkill = CurOption - 1
        IF (InBattle) THEN
          IF (PlayerSkill(CurSkill).SP >= Skill(CurSkill).SP) THEN
            BattleOption = 0
            CloseMenu 3
          END IF
        ELSE
          TextBox SkillDesc(CurSkill)
        END IF
      END IF
    END IF

  CASE 4
    SELECT CASE CurOption
      CASE 0: CloseMenu 4: CallScript 5, 0
      CASE 1: OpenMenu 5
      CASE 2: QuitProgram = 1
    END SELECT

  CASE 5
    CloseMenu 5
    IF (CurOption) THEN CloseMenu 4: LoadGame CurOption - 1

  CASE 6
    CloseMenu 6
    IF (CurOption) THEN SaveGame CurOption - 1

  CASE 7
    CloseMenu 7
    SELECT CASE CurOption
      CASE 0: BattleOption = 3
      CASE 1
        BattleResult = 2
        CloseBattle
        CallScript 6, 0
    END SELECT

END SELECT

END SUB

SUB Move (x, y)

SELECT CASE MoveStatus
  CASE M.PLAYER
    IF ((Entity(0).S.x AND 15) = 0) THEN
      mx = Entity(0).S.x \ 16 + SGN(x)
      my = Entity(0).S.y \ 16 + SGN(y)
      IF (mx < 0) THEN
        IF (ExitX0Map$ <> "") THEN ExitMap ExitX0, ExitX0Map$
      ELSEIF (mx >= MapXSize) THEN
        IF (ExitX1Map$ <> "") THEN ExitMap ExitX1, ExitX1Map$
      ELSE
        IF (my < 0) THEN
          IF (ExitY0Map$ <> "") THEN ExitMap ExitY0, ExitY0Map$
        ELSEIF (my >= MapYSize) THEN
          IF (ExitY1Map$ <> "") THEN ExitMap ExitY1, ExitY1Map$
        ELSE
          IF (TileDat(Map(mx, my)).Solid) THEN BlockedX = -1: BlockedY = -1
          FOR z = NumFixedEntitys TO NumEntitys - 1
            IF (Entity(z).S.Frame <> -1) THEN
              IF (Entity(z).S.x = mx * 16 AND Entity(z).S.y = my * 16) THEN BlockedX = -1: BlockedY = -1
            END IF
          NEXT
          IF (NOT BlockedX) THEN Entity(0).S.x = Entity(0).S.x + x * 16: Moved = -1
          IF (NOT BlockedY) THEN Entity(0).S.y = Entity(0).S.y + y * 16: Moved = -1
          IF (Moved) THEN
            FOR z = NumFixedEntitys TO NumEntitys - 1
              IF (Entity(z).S.Frame = -1) THEN
                IF (Entity(0).S.x = Entity(z).S.x AND Entity(0).S.y = Entity(z).S.y) THEN
                  CurScript = Entity(z).Script
                  ScriptEnt = z
                  ScriptStage = 0
                END IF
              END IF
            NEXT
          END IF
        END IF
      END IF
      IF (x < 0) THEN Entity(0).S.Frame = 10
      IF (x > 0) THEN Entity(0).S.Frame = 11
      IF (y < 0) THEN Entity(0).S.Frame = 9
      IF (y > 0) THEN Entity(0).S.Frame = 0
      NextX = Entity(0).S.x + x * 16
      NextY = Entity(0).S.y + y * 16
      BattleSteps = BattleSteps - 1
    END IF

    Refresh = -1

  CASE M.MENU
    Menu(CurMenu).CursorPos = (Menu(CurMenu).CursorPos + x + y) MOD Menu(CurMenu).NumOptions
    IF (Menu(CurMenu).CursorPos < 0) THEN Menu(CurMenu).CursorPos = Menu(CurMenu).CursorPos + Menu(CurMenu).NumOptions
END SELECT

END SUB

SUB OpenForm (Form)

ShowForm = Form

OpenWindow M.FORM, Form

END SUB

SUB OpenMenu (Menu)

CurMenu = Menu

ShowMenu(NumShowMenus) = Menu
NumShowMenus = NumShowMenus + 1

Menu(Menu).CursorPos = 0

OpenWindow M.MENU, Menu

END SUB

SUB OpenWindow (WinType, WinIndex)

Windows(NumWindows).WinType = WinType
Windows(NumWindows).WinIndex = WinIndex
NumWindows = NumWindows + 1

SetMoveStatus WinType

END SUB

FUNCTION RandBattle

SELECT CASE MapBattles
  CASE 0: RandBattle = INT(RND * 3)
  CASE 1: RandBattle = INT(RND * 3)
  CASE 2: RandBattle = INT(RND * 3)
  CASE 3: RandBattle = INT(RND * 3)
  CASE 4: RandBattle = INT(RND * 3)
END SELECT

END FUNCTION

SUB Render

IF (NOT Refresh) THEN
  IF (NumShowMenus) THEN MenuRender ShowMenu(NumShowMenus - 1)
  IF (NOT ShowForm) THEN FormRender ShowForm
  EXIT SUB
END IF

FOR z = 0 TO NumEntitys - 1
  IF (Entity(z).S.Frame <> -1) THEN
    xp = Entity(z).S.x \ 16: IF (Entity(z).S.x AND 15) THEN xp = xp + 1
    yp = Entity(z).S.y \ 16: IF (Entity(z).S.y AND 15) THEN yp = yp + 1
    EntOT(xp, yp) = z
  END IF
NEXT

SELECT CASE CamStatus
  CASE C.POS:
    CamX = CamPX - 160
    CamY = CamPY - 96
  CASE C.ENTITY
    CamX = Entity(CamPX).S.x - 160
    CamY = Entity(CamPY).S.y - 96    'FIXME: bug here
END SELECT

IF (CamX >= MapXSize * 16 - 320) THEN CamX = MapXSize * 16 - 320
IF (CamY >= MapYSize * 16 - 192) THEN CamY = MapYSize * 16 - 192
IF (CamX < 0) THEN CamX = 0
IF (CamY < 0) THEN CamY = 0

px = CamX AND 15
py = CamY AND 15
tx = CamX \ 16
ty = CamY \ 16
FOR y = 0 TO 11
  FOR x = 0 TO 19
    PUT (px, py), Tiles(ToTil(Map(tx, ty))), PSET
    IF (EntOT(tx, ty) <> -1) THEN
      PUT (Entity(EntOT(tx, ty)).S.x - CamX, Entity(EntOT(tx, ty)).S.y - CamY), Sprites(ToMsk(Entity(EntOT(tx, ty)).S.Frame)), AND
      PUT (Entity(EntOT(tx, ty)).S.x - CamX, Entity(EntOT(tx, ty)).S.y - CamY), Sprites(ToSpr(Entity(EntOT(tx, ty)).S.Frame)), OR
      EntOT(tx, ty) = -1
    END IF
    px = px + 16
    tx = tx + 1
  NEXT
  px = px - 320: py = py + 16
  tx = tx - 20: ty = ty + 1
NEXT

IF (BattleDraw) THEN BattleRender

FOR z = 0 TO NumShowMenus - 1
  MenuRender ShowMenu(z)
NEXT

IF (TextBoxOpen) THEN
  MenuBox -1, 144, 288, 40
  TextOut TextBoxText(0)
END IF

IF (NOT ShowForm) THEN FormRender ShowForm

Refresh = 0

END SUB

SUB SaveGame (Slot)

SaveFileName$ = "save" + LTRIM$(STR$(Slot)) + ".sav"

SaveFile = FREEFILE
OPEN SaveFileName$ FOR BINARY AS SaveFile

PUT SaveFile, , HP
PUT SaveFile, , MaxHP
PUT SaveFile, , MaxDamage
PUT SaveFile, , MinDamage
PUT SaveFile, , Defense
PUT SaveFile, , NumPlayerSkills
PUT SaveFile, , Level
PUT SaveFile, , Expr
PUT SaveFile, , MaxSP

PUT SaveFile, , NumInventorys
FOR z = 0 TO NumInventorys - 1
  PUT SaveFile, , Inventory(z)
NEXT

FOR z = 0 TO NumFlags - 1
  PUT SaveFile, , Flag(z)
NEXT

CLOSE SaveFile

END SUB

SUB SaveStr (File, Dat$, Length)

NDat$ = SPACE$(Length)
MID$(NDat$, 1) = Dat$

PUT File, , NDat$

END SUB

FUNCTION Script (ScriptIndex, EntIndex)

SELECT CASE ScriptIndex
  CASE 0: GotoMap "default", 49, 28

  CASE 1: GotoMap "dshrine", 9, 11

  CASE 2
    SELECT CASE ScriptStage
      CASE 0: IF (Flag(F.DemonGuardDead)) THEN EXIT FUNCTION
        TextBox "Demon Guard: You shall not pass!"
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.DemonGuard, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            Flag(F.DemonGuardDead) = -1
            Entity(EntIndex).S.Frame = -1
            LearnSkill S.Mirror
          END IF
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 3
    SELECT CASE ScriptStage
      CASE 0: HP = MaxHP
        TextBox "A drink from the well restores your" + CHR$(13) + "hit points to maximum."
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN OpenMenu 6 ELSE Script = -1
    END SELECT

  CASE 4: GotoMap "dwrld0", 24, 49

  CASE 5
    TextBox "Oh no, my town! Everyone has been" + CHR$(13) + "killed, and everything except this" + CHR$(13) + "well has been destroyed!"
    TextBox "This looks like the work of the" + CHR$(13) + "demons."
    TextBox "Looks like i'll have to teach them" + CHR$(13) + "not to mess with me!"

  CASE 6
    SELECT CASE ScriptStage
      CASE 0: TextBox "You were defeated."
        TextBox "A giant raven picks your lifeless" + CHR$(13) + "body up from the ground. After a" + CHR$(13) + "long flight, the raven becomes" + CHR$(13) + "distracted by a shiny piece of"
        TextBox "metal on the ground, and drops you."
        HP = 0
        ScriptStage = 1: Script = -1
      CASE 1: IF (NOT TextBoxOpen) THEN GotoMap "default", 29, 28: HP = 1 ELSE Script = -1
    END SELECT

  CASE 7
    SELECT CASE ScriptStage
      CASE 0: IF (Flag(F.DemonLordDead)) THEN EXIT FUNCTION
        TextBox "Demon Lord: You will never stop the" + CHR$(13) + "demons!"
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.DemonLord, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            Flag(F.DemonLordDead) = -1
            Entity(EntIndex).S.Frame = -1
            LearnSkill S.Double
          END IF
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 8
    SELECT CASE ScriptStage
      CASE 0: IF (Flag(F.DemonSlavedriverDead)) THEN EXIT FUNCTION
        TextBox "Demon Slavedriver: I AM THE" + CHR$(13) + "APACALYPSE!"
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.DemonSlavedriver, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            Flag(F.DemonSlavedriverDead) = -1
            Entity(EntIndex).S.Frame = -1
            LearnSkill S.Block
          END IF
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 9
    SELECT CASE ScriptStage
      CASE 0: IF (Flag(F.DemonWarlordDead)) THEN EXIT FUNCTION
        TextBox "Demon Warlord: Prepare for your" + CHR$(13) + "destiny."
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.DemonWarlord, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            Flag(F.DemonWarlordDead) = -1
            Entity(EntIndex).S.Frame = -1
            LearnSkill S.SummonGnome
          END IF
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 10
    SELECT CASE ScriptStage
      CASE 0: IF (Flag(F.DemonShadowlordDead)) THEN EXIT FUNCTION
        TextBox "Demon Shadowlord: You cannot defeat" + CHR$(13) + "the shadow."
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.DemonShadowlord, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            Flag(F.DemonShadowlordDead) = -1
            Entity(EntIndex).S.Frame = -1
          END IF
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 11
    SELECT CASE ScriptStage
      CASE 0
        TextBox "Arch-Demon: You are a fool to" + CHR$(13) + "challenge me, mortal!"
        ScriptStage = 1: Script = -1
      CASE 1
        IF (NOT TextBoxOpen) THEN
          Battle B.ArchDemon, -1
          ScriptStage = 2
        END IF
        Script = -1
      CASE 2
        IF (NOT InBattle) THEN
          IF (BattleResult = 1) THEN
            TextBox "Even though the Arch-Demon had been" + CHR$(13) + "defeated, there was still an" + CHR$(13) + "endless number of demons left."
            TextBox "Otheon would have to spend years" + CHR$(13) + "fighting demons..."
            TextBox "... or will he find another way to" + CHR$(13) + "destroy them all?" + CHR$(13) + CHR$(13) + "Time will tell..."
            ScriptStage = 3
          END IF
        END IF
        Script = -1
      CASE 3
        IF (NOT TextBoxOpen) THEN
          QuitProgram = -1
        ELSE
          Script = -1
        END IF
    END SELECT

  CASE 12: GotoMap "dwrld1", 24, 0

  CASE 13: IF (Flag(F.DemonShadowlordDead)) THEN GotoMap "dwrld4", 9, 11

END SELECT

END FUNCTION

SUB SetBattleSteps

MinSteps = 8
MaxSteps = 27

BattleSteps = INT(RND * (MaxSteps - MinSteps) + 1) + MinSteps

END SUB

SUB SetMoveStatus (Status)

IF (MoveStatus <> M.PLAYER AND Status = M.PLAYER) THEN QB.KeyStop

MoveStatus = Status

IF (Status = M.PLAYER) THEN QB.KeyRate KR.GAME ELSE QB.KeyRate KR.MENU

END SUB

SUB TextBox (Text$)

TextBoxText(NumTextBoxs) = Text$

IF (NumTextBoxs = 0) THEN
  OpenWindow M.TEXTBOX, 0
  TextBoxOpen = -1
  Refresh = -1
END IF

NumTextBoxs = NumTextBoxs + 1

END SUB

SUB TextOut (Text$)

FOR z = 1 TO LEN(Text$)
  C = ASC(MID$(Text$, z, 1))
  SELECT CASE C
    CASE 13: TxCRLF
    CASE ELSE
      PUT (TxX, TxY), Font(C * 68 + 34), AND
      PUT (TxX, TxY), Font(C * 68), OR
      TxX = TxX + 8
  END SELECT
NEXT

END SUB

FUNCTION ToMenuX (Menu)

IF (Menu(Menu).x0 = -1) THEN
  ToMenuX = 160 - Menu(Menu).xs \ 2
ELSE
  ToMenuX = Menu(Menu).x0
END IF

END FUNCTION

FUNCTION ToMenuY (Menu)

IF (Menu(Menu).y0 = -1) THEN
  ToMenuY = 100 - Menu(Menu).ys \ 2
ELSE
  ToMenuY = Menu(Menu).y0
END IF


END FUNCTION

SUB TxCRLF

TxX = TxMarginX
TxY = TxY + 8

END SUB

SUB TxLocate (x, y)

TxX = x: TxY = y
TxMarginX = x

END SUB

SUB Update

IF (InBattle) THEN BattleUpdate

IF (NOT CurScript) THEN
  IF (NOT Script(CurScript, ScriptEnt)) THEN CurScript = -1
END IF

IF (BattleSteps <= 0) THEN
  SetBattleSteps
  IF (NOT MapBattles) THEN Battle RandBattle, 0
END IF

END SUB

FUNCTION UseItem (Item)

SELECT CASE Inventory(Item)

  CASE I.Heal
    IF (HP = MaxHP) THEN
      TextBox "You already have full HP."
      EXIT FUNCTION
    END IF
    IF (MaxHP - HP < 50) THEN Gained = MaxHP - HP ELSE Gained = 50
    HP = HP + Gained
    TextBox "Gained" + STR$(Gained) + " HP"

  CASE I.LgHeal
    IF (HP = MaxHP) THEN
      TextBox "You already have full HP."
      EXIT FUNCTION
    END IF
    IF (MaxHP - HP < 250) THEN Gained = MaxHP - HP ELSE Gained = 250
    HP = HP + Gained
    TextBox "Gained" + STR$(Gained) + " HP"

  CASE I.FullHeal
    IF (HP = MaxHP) THEN
      TextBox "You already have full HP."
      EXIT FUNCTION
    END IF
    Gained = MaxHP - HP
    HP = HP + Gained
    TextBox "Gained" + STR$(Gained) + " HP"

  CASE I.Revive: TextBox "You cannot use this item!"
    EXIT FUNCTION

  CASE I.Restore
    FOR z = 0 TO 4
      IF (PlayerSkill(z).SP <> MaxSP) THEN EXIT FOR
    NEXT
    IF (z = 5) THEN
      TextBox "Your skills are already at max."
      EXIT FUNCTION
    END IF

    FOR z = 0 TO 4
      Gained = MaxSP - PlayerSkill(z).SP
      IF (Gained > 25) THEN Gained = 25
      PlayerSkill(z).SP = PlayerSkill(z).SP + Gained
    NEXT
    TextBox "Skills recharged."

  CASE I.LgRestore
    FOR z = 0 TO 4
      IF (PlayerSkill(z).SP <> MaxSP) THEN EXIT FOR
    NEXT
    IF (z = 5) THEN
      TextBox "Your skills are already at max."
      EXIT FUNCTION
    END IF

    FOR z = 0 TO 4
      Gained = MaxSP - PlayerSkill(z).SP
      IF (Gained > 120) THEN Gained = 120
      IF (Gained) THEN HasGained = -1
      PlayerSkill(z).SP = PlayerSkill(z).SP + Gained
    NEXT
    IF (NOT HasGained) THEN EXIT FUNCTION
    TextBox "Skills recharged."

  CASE I.FullRestore
    FOR z = 0 TO 4
      IF (PlayerSkill(z).SP <> MaxSP) THEN EXIT FOR
    NEXT
    IF (z = 5) THEN
      TextBox "Your skills are already at max."
      EXIT FUNCTION
    END IF

    FOR z = 0 TO 4
      PlayerSkill(z).SP = MaxSP
    NEXT
    TextBox "Skills recharged."

  CASE I.SkillsUp
    MaxSP = MaxSP + 17
    FOR z = 0 TO 4
      PlayerSkill(z).SP = MaxSP
    NEXT
    TextBox "Skills increased."

  CASE I.DefensePill: Defense = Defense + 4
    TextBox "Defense increased."

END SELECT

LoseItem Item

UseItem = -1

END FUNCTION

SUB ViewEntity (EntityIndex)

CamStatus = C.ENTITY
CamPX = EntityIndex

END SUB

