﻿module DWin32.shobjidl;
import win32.windows, win32.objidl, win32.shlobj;
import DWin32.propsys, DWin32.shtypes, DWin32.wtypes;

enum SHCONTF : DWORD
{
	SHCONTF_FOLDERS = 0x20,
	SHCONTF_NONFOLDERS = 0x40,
	SHCONTF_INCLUDEHIDDEN = 0x80,
	SHCONTF_INIT_ON_FIRST_NEXT = 0x100,
	SHCONTF_NETPRINTERSRCH = 0x200,
	SHCONTF_SHAREABLE = 0x400,
	SHCONTF_STORAGE = 0x800,
	SHCONTF_FASTITEMS = 0x2000,
	SHCONTF_FLATLIST = 0x4000,
	SHCONTF_ENABLE_ASYNC = 0x8000
}

enum SIGDN
{
	SIGDN_NORMALDISPLAY = 0,
	SIGDN_PARENTRELATIVEPARSING = 0x80018001,
	SIGDN_DESKTOPABSOLUTEPARSING = 0x80028000,
	SIGDN_PARENTRELATIVEEDITING = 0x80031001,
	SIGDN_DESKTOPABSOLUTEEDITING = 0x8004c000,
	SIGDN_FILESYSPATH = 0x80058000,
	SIGDN_URL = 0x80068000,
	SIGDN_PARENTRELATIVEFORADDRESSBAR = 0x8007c001,
	SIGDN_PARENTRELATIVE = 0x80080001
}

enum SICHINTF : DWORD
{
	SICHINT_DISPLAY = 0,
	SICHINT_ALLFIELDS = 0x80000000,
	SICHINT_CANONICAL = 0x10000000,
	SICHINT_TEST_FILESYSPATH_IF_NOT_EQUAL = 0x20000000
}

const IID IID_IShellItem = { 0x43826d1e, 0xe718, 0x42ee, [0xbc, 0x55, 0xa1, 0xe2, 0x61, 0xc3, 0x7b, 0xfe] };

interface IShellItem : IUnknown
{
	HRESULT BindToHandler(IBindCtx *pbc, REFGUID bhid, REFIID riid, void **ppv);
	HRESULT GetParent(IShellItem **ppsi);
	HRESULT GetDisplayName(SIGDN sigdnName, LPWSTR *ppszName);
	HRESULT GetAttributes(SFGAOF sfgaoMask, SFGAOF *psfgaoAttribs);
	HRESULT Compare(IShellItem *psi, SICHINTF hint, int *piOrder);
}

interface IEnumShellItems : IUnknown
{
	HRESULT Next(ULONG celt, IShellItem **rgelt, ULONG *pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumShellItems **ppenum);
}

interface IFileOperationProgressSink : IUnknown
{
	HRESULT StartOperations();
	HRESULT FinishOperations(HRESULT hrResult);
	HRESULT PreRenameItem(DWORD dwFlags, IShellItem *psiItem, LPCWSTR pszNewName);
	HRESULT PostRenameItem(DWORD dwFlags, IShellItem *psiItem, LPCWSTR pszNewName,
			HRESULT hrRename, IShellItem *psiNewlyCreated);
	HRESULT PreMoveItem(DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder,
			LPCWSTR pszNewName);
	HRESULT PostMoveItem(DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder,
			LPCWSTR pszNewName, HRESULT hrMove, IShellItem *psiNewlyCreated);
	HRESULT PreCopyItem(DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder,
			LPCWSTR pszNewName);
	HRESULT PostCopyItem(DWORD dwFlags, IShellItem *psiItem, IShellItem *psiDestinationFolder,
		LPCWSTR pszNewName, HRESULT hrCopy, IShellItem *psiNewlyCreated);
	HRESULT PreDeleteItem(DWORD dwFlags, IShellItem *psiItem);
	HRESULT PostDeleteItem(DWORD dwFlags, IShellItem *psiItem, HRESULT hrDelete,
		IShellItem *psiNewlyCreated);
	HRESULT PreNewItem(DWORD dwFlags, IShellItem *psiDestinationFolder, LPCWSTR pszNewName);
	HRESULT PostNewItem(DWORD dwFlags, IShellItem *psiDestinationFolder, LPCWSTR pszNewName,
			LPCWSTR pszTemplateName, DWORD dwFileAttributes, HRESULT hrNew,
			IShellItem *psiNewItem);
	HRESULT UpdateProgress(UINT iWorkTotal, UINT iWorkSoFar);
	HRESULT ResetTimer();
	HRESULT PauseTimer();
	HRESULT ResumeTimer();
}

enum SIATTRIBFLAGS
{
	SIATTRIBFLAGS_AND = 0x1,
	SIATTRIBFLAGS_OR = 0x2,
	SIATTRIBFLAGS_APPCOMPAT = 0x3,
	SIATTRIBFLAGS_MASK = 0x3,
	SIATTRIBFLAGS_ALLITEMS = 0x4000
}

interface IShellItemArray : IUnknown
{
	HRESULT BindToHandler(IBindCtx *pbc, REFGUID bhid, REFIID riid, void **ppvOut);
	HRESULT GetPropertyStore(GETPROPERTYSTOREFLAGS flags, REFIID riid, void **ppv);
	HRESULT GetPropertyDescriptionList(REFPROPERTYKEY keyType, REFIID riid, void **ppv);
	HRESULT GetAttributes(SIATTRIBFLAGS AttribFlags, SFGAOF sfgaoMask, SFGAOF *psfgaoAttribs);
	HRESULT GetCount(DWORD *pdwNumItems);
	HRESULT GetItemAt(DWORD dwIndex, IShellItem **ppsi);
	HRESULT EnumItems(IEnumShellItems **ppenumShellItems);
}

interface IModalWindow : IUnknown
{
	HRESULT Show(HWND hwndParent);
}

enum FDE_OVERWRITE_RESPONSE
{
	FDEOR_DEFAULT = 0,
	FDEOR_ACCEPT = 0x1,
	FDEOR_REFUSE = 0x2
}

enum FDE_SHAREVIOLATION_RESPONSE
{
	FDESVR_DEFAULT = 0,
	FDESVR_ACCEPT = 0x1,
	FDESVR_REFUSE = 0x2
}

enum FDAP
{
	FDAP_BOTTOM = 0,
	FDAP_TOP = 0x1
}

interface IFileDialogEvents : IUnknown
{
	HRESULT OnFileOk(IFileDialog *pfd);
	HRESULT OnFolderChanging(IFileDialog *pfd, IShellItem *psiFolder);
	HRESULT OnFolderChange(IFileDialog *pfd);
	HRESULT OnSelectionChange(IFileDialog *pfd);
	HRESULT OnShareViolation(IFileDialog *pfd, IShellItem *psi,
			FDE_SHAREVIOLATION_RESPONSE *pResponse);
	HRESULT OnTypeChange(IFileDialog *pfd);
	HRESULT OnOverwrite(IFileDialog *pfd, IShellItem *psi, FDE_OVERWRITE_RESPONSE *pResponse);
}

enum FILEOPENDIALOGOPTIONS : DWORD
{
	FOS_OVERWRITEPROMPT = 0x2,
	FOS_STRICTFILETYPES = 0x4,
	FOS_NOCHANGEDIR = 0x8,
	FOS_PICKFOLDERS = 0x20,
	FOS_FORCEFILESYSTEM = 0x40,
	FOS_ALLNONSTORAGEITEMS = 0x80,
	FOS_NOVALIDATE = 0x100,
	FOS_ALLOWMULTISELECT = 0x200,
	FOS_PATHMUSTEXIST = 0x800,
	FOS_FILEMUSTEXIST = 0x1000,
	FOS_CREATEPROMPT = 0x2000,
	FOS_SHAREAWARE = 0x4000,
	FOS_NOREADONLYRETURN = 0x8000,
	FOS_NOTESTFILECREATE = 0x10000,
	FOS_HIDEMRUPLACES = 0x20000,
	FOS_HIDEPINNEDPLACES = 0x40000,
	FOS_NODEREFERENCELINKS = 0x100000,
	FOS_DONTADDTORECENT = 0x2000000,
	FOS_FORCESHOWHIDDEN = 0x10000000,
	FOS_DEFAULTNOMINIMODE = 0x20000000,
	FOS_FORCEPREVIEWPANEON = 0x40000000
}

interface IFileDialog : IModalWindow
{
	HRESULT SetFileTypes(UINT cFileTypes, COMDLG_FILTERSPEC *rgFilterSpec);
	HRESULT SetFileTypeIndex(UINT iFileType);
	HRESULT GetFileTypeIndex(UINT *piFileType);
	HRESULT Advise(IFileDialogEvents pfde, DWORD *pdwCookie);
	HRESULT Unadvise(DWORD dwCookie);
	HRESULT SetOptions(FILEOPENDIALOGOPTIONS fos);
	HRESULT GetOptions(FILEOPENDIALOGOPTIONS* pfos);
	HRESULT SetDefaultFolder(IShellItem psi);
	HRESULT SetFolder(IShellItem psi);
	HRESULT GetFolder(IShellItem *ppsi);
	HRESULT GetCurrentSelection(IShellItem *ppsi);
	HRESULT SetFileName(LPCWSTR pszName);
	HRESULT GetFileName(LPWSTR *pszName);
	HRESULT SetTitle(LPCWSTR pszTitle);
	HRESULT SetOkButtonLabel(LPCWSTR pszText);
	HRESULT SetFileNameLabel(LPCWSTR pszLabel);
	HRESULT GetResult(IShellItem *ppsi);
	HRESULT AddPlace(IShellItem psi, FDAP fdap);
	HRESULT SetDefaultExtension(LPCWSTR pszDefaultExtension);
	HRESULT Close(HRESULT hr);
	HRESULT SetClientGuid(REFGUID guid);
	HRESULT ClearClientData();
	HRESULT SetFilter(IShellItemFilter pFilter);
}

const IID IID_IFileSaveDialog = {0x84bccd23, 0x5fde, 0x4cdb, [0xae, 0xa4, 0xaf, 0x64, 0xb8, 0x3d, 0x78, 0xab]};

interface IFileSaveDialog : IFileDialog
{
	HRESULT SetSaveAsItem(IShellItem *psi);
	HRESULT SetProperties(IPropertyStore *pStore);
	HRESULT SetCollectedProperties(IPropertyDescriptionList *pList, BOOL fAppendDefault);
	HRESULT GetProperties(IPropertyStore **ppStore);
	HRESULT ApplyProperties(IShellItem *psi, IPropertyStore *pStore, HWND hwnd,
			IFileOperationProgressSink *pSink);
}

const IID IID_IFileOpenDialog = {0xd57c7288, 0xd4ad, 0x4768, [0xbe, 0x02, 0x9d, 0x96, 0x95, 0x32, 0xd9, 0x60]};

interface IFileOpenDialog : IFileDialog
{
	HRESULT GetResults(IShellItemArray **ppenum);
	HRESULT GetSelectedItems(IShellItemArray **ppsai);
}

enum KF_CATEGORY
{
	KF_CATEGORY_VIRTUAL = 0x1,
	KF_CATEGORY_FIXED = 0x2,
	KF_CATEGORY_COMMON = 0x3,
	KF_CATEGORY_PERUSER = 0x4
}

enum KF_DEFINITION_FLAGS : DWORD
{
	KFDF_LOCAL_REDIRECT_ONLY = 0x2,
	KFDF_ROAMABLE = 0x4,
	KFDF_PRECREATE = 0x8
}

enum KF_REDIRECT_FLAGS : DWORD
{
	KF_REDIRECT_USER_EXCLUSIVE = 0x1,
	KF_REDIRECT_COPY_SOURCE_DACL = 0x2,
	KF_REDIRECT_OWNER_USER = 0x4,
	KF_REDIRECT_SET_OWNER_EXPLICIT = 0x8,
	KF_REDIRECT_CHECK_ONLY = 0x10,
	KF_REDIRECT_WITH_UI = 0x20,
	KF_REDIRECT_UNPIN = 0x40,
	KF_REDIRECT_PIN = 0x80,
	KF_REDIRECT_COPY_CONTENTS = 0x200,
	KF_REDIRECT_DEL_SOURCE_CONTENTS = 0x400,
	KF_REDIRECT_EXCLUDE_ALL_KNOWN_SUBFOLDERS = 0x800
}

enum KF_REDIRECTION_CAPABILITIES
{
	KF_REDIRECTION_CAPABILITIES_ALLOW_ALL = 0xff,
	KF_REDIRECTION_CAPABILITIES_REDIRECTABLE = 0x1,
	KF_REDIRECTION_CAPABILITIES_DENY_ALL = 0xfff00,
	KF_REDIRECTION_CAPABILITIES_DENY_POLICY_REDIRECTED = 0x100,
	KF_REDIRECTION_CAPABILITIES_DENY_POLICY = 0x200,
	KF_REDIRECTION_CAPABILITIES_DENY_PERMISSIONS = 0x400
}

struct KNOWNFOLDER_DEFINITION
{
	KF_CATEGORY category;
	LPWSTR pszName;
	LPWSTR pszDescription;
	KNOWNFOLDERID fidParent;
	LPWSTR pszRelativePath;
	LPWSTR pszParsingName;
	LPWSTR pszTooltip;
	LPWSTR pszLocalizedName;
	LPWSTR pszIcon;
	LPWSTR pszSecurity;
	DWORD dwAttributes;
	KF_DEFINITION_FLAGS kfdFlags;
	FOLDERTYPEID ftidType;
}

const IID IID_IKnownFolder = {0x3AA7AF7E, 0x9B36, 0x420c, [0xA8, 0xE3, 0xF7, 0x7D, 0x46, 0x74, 0xA4, 0x88]};

interface IKnownFolder : IUnknown
{
	HRESULT GetId(KNOWNFOLDERID *pkfid);
	HRESULT GetCategory(KF_CATEGORY *pCategory);
	HRESULT GetShellItem(DWORD dwFlags, REFIID riid, void **ppv);
	HRESULT GetPath(DWORD dwFlags, LPWSTR *ppszPath);
	HRESULT SetPath(DWORD dwFlags, LPCWSTR pszPath);
	HRESULT GetIDList(DWORD dwFlags, PIDLIST_ABSOLUTE *ppidl);
	HRESULT GetFolderType(FOLDERTYPEID *pftid);
	HRESULT GetRedirectionCapabilities(KF_REDIRECTION_CAPABILITIES *pCapabilities);
	HRESULT GetFolderDefinition(KNOWNFOLDER_DEFINITION *pKFD);
}

enum FFFP_MODE
{
	FFFP_EXACTMATCH = 0,
	FFFP_NEARESTPARENTMATCH = ( FFFP_EXACTMATCH + 1 )
}

const IID IID_IKnownFolderManager = {0x8BE2D872, 0x86AA, 0x4d47, [0xB7, 0x76, 0x32, 0xCC, 0xA4, 0x0C, 0x70, 0x18]};

interface IKnownFolderManager : IUnknown
{
	HRESULT FolderIdFromCsidl(int nCsidl, KNOWNFOLDERID *pfid);
	HRESULT FolderIdToCsidl(DWin32.shtypes.REFKNOWNFOLDERID rfid, int *pnCsidl);
	HRESULT GetFolderIds(KNOWNFOLDERID **ppKFId, UINT *pCount);
	HRESULT GetFolder(DWin32.shtypes.REFKNOWNFOLDERID rfid, IKnownFolder **ppkf);
	HRESULT GetFolderByName(LPCWSTR pszCanonicalName, IKnownFolder **ppkf);
	HRESULT RegisterFolder(DWin32.shtypes.REFKNOWNFOLDERID rfid, const KNOWNFOLDER_DEFINITION *pKFD);
	HRESULT UnregisterFolder(DWin32.shtypes.REFKNOWNFOLDERID rfid);
	HRESULT FindFolderFromPath(LPCWSTR pszPath, FFFP_MODE mode, IKnownFolder **ppkf);
	HRESULT FindFolderFromIDList(PCIDLIST_ABSOLUTE pidl, IKnownFolder **ppkf);
	HRESULT Redirect(DWin32.shtypes.REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags,
			LPCWSTR pszTargetPath, UINT cFolders, const KNOWNFOLDERID *pExclusion,
			LPWSTR *ppszError);
}

interface IShellItemFilter : IUnknown
{
	HRESULT IncludeItem(IShellItem *psi);
	HRESULT GetEnumFlagsForItem(IShellItem *psi, SHCONTF *pgrfFlags);
}

const GUID CLSID_FileOpenDialog = {0xdc1c5a9c, 0xe88a, 0x4dde, [0xa5, 0xa1, 0x60, 0xf8, 0x2a, 0x20, 0xae, 0xf7]};

const GUID CLSID_FileSaveDialog = {0xc0b4e2f3, 0xba21, 0x4773, [0x8d, 0xba, 0x33, 0x5e, 0xc9, 0x46, 0xeb, 0x8b]};

const GUID CLSID_KnownFolderManager = {0x4df0c730, 0xdf9d, 0x4ae3, [0x91, 0x53, 0xaa, 0x6b, 0x82, 0xe9, 0x79, 0x5a]};