﻿module Text.CTextFragment;
import freetype.ft;
import Tractor.Tractor;

class CTextFragment
{
	private bool mImage;
	private IFont mFont;
	private int mFontSize;
	private CColour mColour;
	private float mAlpha;
	private string mText;
	private ITexture mTexture;
	private FT_Pos mX;
	private FT_Pos mY;
	private FT_Pos mBaselineY;
	private FT_F26Dot6 mXSize;
	private FT_F26Dot6 mYSize;

	public this(IFont aFont, int aFontSize, CColour aColour, float aAlpha, string aText,
			FT_Pos aX, FT_Pos aY, FT_F26Dot6 aBaselineY, FT_F26Dot6 aXSize, FT_F26Dot6 aYSize)
	in
	{
		assert(aText != "");
	}
	body
	{
		mImage = false;
		mFont = aFont;
		mFontSize = aFontSize;
		mColour = aColour;
		mAlpha = aAlpha;
		mText = aText;
		mX = aX;
		mY = aY;
		mBaselineY = aBaselineY;
		mXSize = aXSize;
		mYSize = aYSize;
	}



	public this(CColour aColour, float aAlpha, ITexture aTexture, FT_Pos aX, FT_Pos aY,
			FT_Pos aBaselineY, FT_F26Dot6 aXSize, FT_F26Dot6 aYSize)
	{
		mImage = true;
		mColour = aColour;
		mAlpha = aAlpha;
		mTexture = aTexture;
		mX = aX;
		mY = aY;
		mBaselineY = aBaselineY;
		mXSize = aXSize;
		mYSize = aYSize;
	}



	public bool IsImage()
	{
		return mImage;
	}



	public IFont Font()
	in
	{
		assert(!mImage);
	}
	body
	{
		return mFont;
	}



	public int FontSize()
	in
	{
		assert(!mImage);
	}
	body
	{
		return mFontSize;
	}



	public CColour Colour()
	{
		return mColour;
	}



	public float Alpha()
	{
		return mAlpha;
	}



	public string Text()
	in
	{
		assert(!mImage);
	}
	body
	{
		return mText;
	}



	public ITexture Texture()
	in
	{
		assert(mImage);
	}
	body
	{
		return mTexture;
	}



	public FT_Pos X()
	{
		return mX;
	}



	public FT_Pos Y()
	{
		return mY;
	}



	public FT_Pos BaselineY()
	{
		return mBaselineY;
	}



	public FT_F26Dot6 XSize()
	{
		return mXSize;
	}



	public FT_F26Dot6 YSize()
	{
		return mYSize;
	}
}