﻿module Text.CWrite;
import freetype.ft;
import Tractor.Tractor;

class CWrite
{
	private bool mImage;
	private IFont mFont;
	private FT_F26Dot6 mFontSize;
	private CColour mColour;
	private float mAlpha;
	private string mText;
	private ITexture mTexture;

	public this(IFont aFont, FT_F26Dot6 aFontSize, CColour aColour, float aAlpha, string aText)
	in
	{
		assert(aFont !is null);
		assert(aFontSize > 1);
		assert(aText != "");
	}
	body
	{
		mImage = false;
		mFont = aFont;
		mFontSize = aFontSize;
		mColour = aColour;
		mAlpha = aAlpha;
		mText = aText;
	}

	public this(IFont aFont, FT_F26Dot6 aFontSize, CColour aColour, float aAlpha, ITexture aTexture)
	in
	{
		assert(aFont !is null);
		assert(aFontSize > 1);
	}
	body
	{
		mImage = true;
		mFont = aFont;
		mFontSize = aFontSize;
		mColour = aColour;
		mAlpha = aAlpha;
		mTexture = aTexture;
	}



	public bool IsImage()
	{
		return mImage;
	}



	public IFont Font()
	{
		return mFont;
	}



	public FT_F26Dot6 FontSize()
	{
		return mFontSize;
	}



	public CColour Colour()
	{
		return mColour;
	}



	public float Alpha()
	{
		return mAlpha;
	}



	public string Text()
	in
	{
		assert(!mImage);
	}
	body
	{
		return mText;
	}



	public ITexture Texture()
	in
	{
		assert(mImage);
	}
	body
	{
		return mTexture;
	}
}