﻿module Windows.Main;
import core.runtime;
import std.utf;
import win32.windows;
import Tractor.Engine;
import Game.CController;

immutable string cProgramName = "Otheon's Adventure";

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	try
	{
		Runtime.initialize();
		auto Engine = CreateEngine(hInstance, cProgramName, new CController());
		Engine.Run();
		Runtime.terminate();
	}
	catch (Throwable e)
	{
		MessageBox(null, toUTF16z("Fatal error: " ~ e.toString()), toUTF16z(cProgramName), MB_OK | MB_ICONERROR);
	}
	return 0;
}