﻿module QBasic.Interpreter.CReference;
import QBasic.Program.CName, QBasic.Program.CType;

class CReference
{
	private CName mName;
	public immutable int StackFrame;
	public immutable int[] Subscripts;
	public immutable int RecordOffset;
	private CType mType;

	public this(CName aName, int aStackFrame, immutable(int[]) aSubscripts, int aRecordOffset,
			CType aType)
	in
	{
		assert((aName.Shared && aStackFrame == -1) || (!aName.Shared && aStackFrame >= 0));
	}
	body
	{
		mName = aName;
		StackFrame = aStackFrame;
		Subscripts = aSubscripts;
		RecordOffset = aRecordOffset;
		mType = aType;
	}



	public CName Name()
	{
		return mName;
	}

	public const(CName) Name() const
	{
		return mName;
	}



	public CType Type()
	{
		return mType;
	}

	public const(CType) Type() const
	{
		return mType;
	}
}