﻿module QBasic.Interpreter.CStackFrame;
import QBasic.Interpreter.CExpressionInterpreter, QBasic.Interpreter.CVariable,
		QBasic.Interpreter.CVariableCollection, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CProcedure, QBasic.Program.CType, QBasic.Program.CValue;

class CStackFrame
{
	private CProcedure mProcedure;
	public CExpressionInterpreter ExpressionInterpreter = null;
	public IInstructionInterpreter InstructionInterpreter = null;
	public int InstructionIndex = 0;
	public int InstructionStage = 0;
	private CVariableCollection mVariables;
	public CValue ReturnValue;
	public CValue[] Stack;

	public this(CProcedure aProcedure)
	{
		mProcedure = aProcedure;
		mVariables = new CVariableCollection(Procedure.Variables);
		Stack.length = aProcedure.StackSize;
	}



	public CProcedure Procedure()
	{
		return mProcedure;
	}



	public CVariableCollection Variables()
	{
		return mVariables;
	}
}