﻿module QBasic.Interpreter.CVariableCollection;
import QBasic.Interpreter.CVariable, QBasic.Program.CIdentifier, QBasic.Program.CType,
		QBasic.Program.CValue, QBasic.Program.CVariableInfo;

class CVariableCollection
{
	private CVariable[CIdentifier] mVariables;

	public this(CVariableInfo[CIdentifier] aVariables)
	{
		foreach (CIdentifier Identifier, CVariableInfo Info; aVariables)
			mVariables[Identifier] = new CVariable(Info);
	}



	public const(CVariable[CIdentifier]) Variables() const
	{
		return mVariables;
	}



	public void Set(CIdentifier aIdentifier, immutable(int[]) aSubscripts, int aRecordOffset,
			CValue aValue)
	{
		mVariables[aIdentifier].Set(aSubscripts, aRecordOffset, aValue);
	}



	public CValue* GetReference(CIdentifier aIdentifier, immutable(int[]) aSubscripts,
			int aRecordOffset)
	{
		return mVariables[aIdentifier].GetReference(aSubscripts, aRecordOffset);
	}



	public void ResizeArray(CIdentifier aIdentifier, const(int[]) aNewDimensions)
	{
		mVariables[aIdentifier].ResizeArray(aNewDimensions);
	}



	public bool WriteData(CIdentifier aIdentifier, const(int[]) aSubscripts,
			int aRecordOffset, const(ubyte[]) aData)
	{
		return mVariables[aIdentifier].WriteData(aSubscripts, aRecordOffset, aData);
	}



	public bool IsArrayReference(CIdentifier aIdentifier)
	{
		return mVariables[aIdentifier].IsArrayReference;
	}



	public immutable(ubyte[]) ReadData(CIdentifier aIdentifier, const(int[]) aSubscripts,
			int aRecordOffset, int aByteSize)
	{
		return mVariables[aIdentifier].ReadData(aSubscripts, aRecordOffset, aByteSize);
	}
}