﻿module QBasic.Interpreter.Instructions.CAssignmentInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.CReference,
		QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CAssignmentInstruction;

class CAssignmentInterpreter : IInstructionInterpreter
{
	private CReference mTarget;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CAssignmentInstruction Instruction = cast(CAssignmentInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.TargetExpression, aBlocking))
						return false;
					break;
				case 1:
					mTarget = aState.GetExpressionResult().Reference;
					if (!aState.Expression(Instruction.Expression, aBlocking))
						return false;
					break;
				case 2:
					if (Instruction.BinaryCopy)
					{
						auto Source = aState.GetExpressionResult().Reference;
						auto Data = aState.ReadData(Source, aState.ValueSize(mTarget));
						if (Data is null)
							return false;
						aState.WriteData(mTarget, Data);
					}
					else
						aState.WriteVariable(mTarget, aState.GetExpressionResult());
					return true;
				default:
					assert(false);
			}
		}
	}
}