﻿module QBasic.Interpreter.Instructions.CBLoadInterpreter;
import QBasic.CCP437Encoder, QBasic.Interpreter.IInterpreterState,
		QBasic.Interpreter.Instructions.IInstructionInterpreter, QBasic.Program.Instructions.CBLoadInstruction;

class CBLoadInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CBLoadInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage == 0)
			{
				if (aState.Expression(Instruction.FileNameExpression, aBlocking))
					return false;
			}
			else
			{
				assert(Stage == 1);
				auto CP437 = new CCP437Encoder();
				auto Path = CP437.Decode(aState.GetExpressionResult().StringValue);
				ubyte[] Data;
				if (!aState.FileSystem.BLoad(Path, Data))
					return false;
				return aState.WriteData(Data);
			}
		}
	}
}