﻿module QBasic.Interpreter.Instructions.CDefSegInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CDefSegInstruction;

class CDefSegInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CDefSegInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage == 0)
			{
				if (Instruction.AddressExpression is null)
				{
					aState.SetDefSeg(null);
					return true;
				}
				if (!aState.Expression(Instruction.AddressExpression, aBlocking))
					return false;
			}
			else
			{
				assert(Stage == 1);
				auto Reference = aState.GetExpressionResult().Reference;
				aState.SetDefSeg(Reference);
				return true;
			}
		}
	}
}