module QBasic.Interpreter.Instructions.CExtensionCommandInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CValue, QBasic.Program.Instructions.CExtensionCommandInstruction;

class CExtensionCommandInterpreter : IInstructionInterpreter
{
	private CValue[] mArguments;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CExtensionCommandInstruction Instruction = cast(CExtensionCommandInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage != 0)
				mArguments ~= aState.GetExpressionResult();
			if (Stage < Instruction.Arguments.length)
			{
				if (!aState.Expression(Instruction.Arguments[Stage], aBlocking))
					return false;
			}
			else
			{
				assert(Stage == Instruction.Arguments.length);
				aState.ExtensionCommand(Instruction.Command, mArguments);
				return true;
			}
		}
	}
}