﻿module QBasic.Interpreter.Instructions.CFileCloseInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CFileCloseInstruction;

class CFileCloseInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CFileCloseInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.FileNumberExpression, aBlocking))
						return false;
					break;
				case 1:
					int Number = aState.GetExpressionResult().IntegralValue;
					return aState.FileSystem.Close(Number);
				default:
					assert(false);
			}
		}
	}
}