﻿module QBasic.Interpreter.Instructions.CFileLineInputInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CValue, QBasic.Program.Instructions.CFileLineInputInstruction;

class CFileLineInputInterpreter : IInstructionInterpreter
{
	private int mNumber;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CFileLineInputInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.FileNumberExpression, aBlocking))
						return false;
					break;
				case 1:
					mNumber = aState.GetExpressionResult().IntegralValue;
					if (!aState.Expression(Instruction.TargetExpression, aBlocking))
						return false;
					break;
				case 2:
					auto Target = aState.GetExpressionResult().Reference;
					ubyte[] Line;
					if (!aState.FileSystem.ReadLine(mNumber, Line))
						return false;
					aState.WriteVariable(Target, CValue.String(Line.idup));
					return true;
				default:
					assert(false);
			}
		}
	}
}