﻿module QBasic.Interpreter.Instructions.CFileOpenInterpreter;
import QBasic.CCP437Encoder, QBasic.Interpreter.IInterpreterState,
		QBasic.Interpreter.Instructions.IInstructionInterpreter, QBasic.Program.Instructions.CFileOpenInstruction;

class CFileOpenInterpreter : IInstructionInterpreter
{
	private string mPath;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CFileOpenInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.PathExpression, aBlocking))
						return false;
					break;
				case 1:
					auto CP437 = new CCP437Encoder();
					mPath = CP437.Decode(aState.GetExpressionResult().StringValue);
					if (!aState.Expression(Instruction.NumberExpression, aBlocking))
						return false;
					break;
				case 2:
					int Number = aState.GetExpressionResult().IntegralValue;
					return aState.FileSystem.Open(Number, Instruction.Mode, mPath);
				default:
					throw new Exception("Invalid instruction stage");
			}
		}
	}
}