﻿module QBasic.Interpreter.Instructions.CFileSeekInterpreter;
import QBasic.Interpreter.Instructions.IInstructionInterpreter, QBasic.Interpreter.IInterpreterState,
		QBasic.Program.Instructions.CFileSeekInstruction;

class CFileSeekInterpreter : IInstructionInterpreter
{
	private int mFileNumber;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CFileSeekInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (aState.Expression(Instruction.NumberExpression, aBlocking))
						return false;
					break;
				case 1:
					mFileNumber = aState.GetExpressionResult().IntegralValue;
					if (aState.Expression(Instruction.PositionExpression, aBlocking))
						return false;
					break;
				case 2:
					int Position = aState.GetExpressionResult().IntegralValue;
					return aState.FileSystem.Seek(mFileNumber, Position);
				default:
					assert(false);
			}
		}
	}
}