﻿module QBasic.Interpreter.Instructions.CForInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CValue, QBasic.Program.Instructions.CForInstruction;

class CForInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CForInstruction Instruction = cast(CForInstruction)aState.GetInstruction();
		auto Target = aState.GetStack(Instruction.GetStackOffset()).Reference;
		int Iterator = aState.ReadVariable(Target).IntegralValue;
		int Step = aState.GetStack(Instruction.GetStackOffset() + 2).IntegralValue;
		assert(Step != 0);
		int End = aState.GetStack(Instruction.GetStackOffset() + 1).IntegralValue;
		if (Step > 0 && Iterator > End || Step < 0 && Iterator < End)
			aState.NextInstruction(Instruction.GetNextInstruction());
		return true;
	}
}