﻿module QBasic.Interpreter.Instructions.CForNextInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CType, QBasic.Program.CValue, QBasic.Program.Instructions.CForNextInstruction;

class CForNextInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CForNextInstruction)aState.GetInstruction();
		auto Target = aState.GetStack(Instruction.GetStackOffset()).Reference;
		int Iterator = aState.ReadVariable(Target).IntegralValue;
		int Step = aState.GetStack(Instruction.GetStackOffset() + 2).IntegralValue;
		assert(Step != 0);
		aState.WriteVariable(Target, CValue.Integer(Iterator + Step));
		aState.NextInstruction(Instruction.GetStartInstruction());
		return true;
	}
}