﻿module QBasic.Interpreter.Instructions.CGraphicsLineInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CGraphicsLineInstruction;

class CGraphicsLineInterpreter : IInstructionInterpreter
{
	private int mX0;
	private int mY0;
	private int mX1;
	private int mY1;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CGraphicsLineInstruction)aState.GetInstruction();
		for (int i = aState.GetInstructionStage(); ; i++)
		{
			switch (i)
			{
				case 0:
					if (aState.Expression(Instruction.X0Expression, aBlocking))
						return false;
					break;
				case 1:
					mX0 = aState.GetExpressionResult().IntegralValue;
					if (aState.Expression(Instruction.Y0Expression, aBlocking))
						return false;
					break;
				case 2:
					mY0 = aState.GetExpressionResult().IntegralValue;
					if (aState.Expression(Instruction.X1Expression, aBlocking))
						return false;
					break;
				case 3:
					mX1 = aState.GetExpressionResult().IntegralValue;
					if (aState.Expression(Instruction.Y1Expression, aBlocking))
						return false;
					break;
				case 4:
					mY1 = aState.GetExpressionResult().IntegralValue;
					if (aState.Expression(Instruction.ColourExpression, aBlocking))
						return false;
					break;
				case 5:
					int Colour = aState.GetExpressionResult().IntegralValue;
					return aState.Graphics.Line(mX0, mY0, mX1, mY1, Colour, Instruction.Type);
				default:
					throw new Exception("Invalid instruction stage");
			}
		}
	}
}