﻿module QBasic.Interpreter.Instructions.CGraphicsPutInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CGraphicsPutInstruction;

class CGraphicsPutInterpreter : IInstructionInterpreter
{
	private int mX;
	private int mY;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CGraphicsPutInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.XExpression, aBlocking))
						return false;
					break;
				case 1:
					mX = aState.GetExpressionResult().IntegralValue;
					if (!aState.Expression(Instruction.YExpression, aBlocking))
						return false;
					break;
				case 2:
					mY = aState.GetExpressionResult().IntegralValue;
					if (!aState.Expression(Instruction.ImageExpression, aBlocking))
						return false;
					break;
				case 3:
					auto Image = aState.GetExpressionResult();
					return aState.Graphics.Put(mX, mY, Image.Reference, Instruction.Operation);
				default:
					assert(false);
			}
		}
	}
}