﻿module QBasic.Interpreter.Instructions.CIfInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CIfInstruction;

class CIfInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CIfInstruction Instruction = cast(CIfInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.GetConditionExpression(), aBlocking))
						return false;
					break;
				case 1:
					if (aState.GetExpressionResult().IntegralValue == 0)
						aState.NextInstruction(Instruction.GetNextInstruction());
					return true;
				default:
					throw new Throwable("Invalid instruction stage");
			}
		}
	}
}