﻿module QBasic.Interpreter.Instructions.CLoopStartInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CValue, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Instructions.CLoopStartInstruction;

class CLoopStartInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CLoopStartInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage == 0)
			{
				CExpression Expression = Instruction.GetExpression();
				if (Expression is null)
				{
					if (Instruction.GetUntil())   // magic: if it is a loop end, go back to the start
						aState.NextInstruction(Instruction.GetNextInstruction());
					return true;
				}
				if (!aState.Expression(Expression, aBlocking))
					return false;
			}
			else
			{
				assert(Stage == 1);
				bool Condition = aState.GetExpressionResult().IntegralValue != 0;
				if (Condition == Instruction.GetUntil())
					aState.NextInstruction(Instruction.GetNextInstruction());
				return true;
			}
		}
	}
}