﻿module QBasic.Interpreter.Instructions.CRedimInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CRedimInstruction;

class CRedimInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		auto Instruction = cast(CRedimInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage == 0)
			{
				if (!aState.Expression(Instruction.SubscriptExpression, aBlocking))
					return false;
			}
			else
			{
				assert(Stage == 1);
				int Subscript = aState.GetExpressionResult().IntegralValue;
				aState.ResizeArray(Instruction.Name, [ Subscript + 1 ]);
				return true;
			}
		}
	}
}