﻿module QBasic.Interpreter.Instructions.CSelectInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CType, QBasic.Program.CValue, QBasic.Program.Instructions.CSelectInstruction;

class CSelectInterpreter : IInstructionInterpreter
{
	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CSelectInstruction Instruction = cast(CSelectInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			switch (Stage)
			{
				case 0:
					if (!aState.Expression(Instruction.GetExpression(), aBlocking))
						return false;
					break;
				case 1:
					aState.SetStack(Instruction.GetStackOffset(), aState.GetExpressionResult());
					return true;
				default:
					throw new Throwable("Invalid instruction stage");
			}
		}
	}
}