﻿module QBasic.Interpreter.Instructions.CSubCallInterpreter;
import QBasic.Interpreter.IInterpreterState, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CValue, QBasic.Program.Instructions.CSubCallInstruction;

class CSubCallInterpreter : IInstructionInterpreter
{
	private CValue[] mArguments;

	public bool Execute(IInterpreterState aState, out bool aBlocking)
	{
		CSubCallInstruction Instruction = cast(CSubCallInstruction)aState.GetInstruction();
		for (int Stage = aState.GetInstructionStage(); ; Stage++)
		{
			if (Stage != 0)
				mArguments ~= [ aState.GetExpressionResult() ];
			if (Stage < Instruction.GetArguments().length)
			{
				if (!aState.Expression(Instruction.GetArguments()[Stage], aBlocking))
					return false;
			}
			else
			{
				assert(Stage == Instruction.GetArguments().length);
				aState.CallProcedure(Instruction.GetSubName(), mArguments);
				return true;
			}
		}
	}
}