﻿module QBasic.Parser.Expressions.CBinaryOperatorExpressionNode;
import std.typecons;
import QBasic.Parser.Expressions.CExpressionNode, QBasic.Program.CType,
		QBasic.Program.EOperator;

class CBinaryOperatorExpressionNode : CExpressionNode
{
	public immutable EOperator Operator;
	private Nullable!EPrimitiveType mType;

	public this(EOperator aOperator)
	{
		Operator = aOperator;
	}



	public override EExpressionNodeType NodeType()
	{
		return EExpressionNodeType.BinaryOperator;
	}



	public override EPrimitiveType Type()
	in
	{
		assert(Complete && !mType.isNull);
	}
	body
	{
		return mType;
	}



	public void SetType(EPrimitiveType aType)
	in
	{
		assert(!Complete && mType.isNull);
	}
	body
	{
		mType = aType;
	}
}