﻿module QBasic.Parser.Expressions.CBuiltinFunctionExpressionNode;
import QBasic.Parser.Expressions.CExpressionNode, QBasic.Parser.Expressions.CFunctionExpressionNode,
		QBasic.Program.CType, QBasic.Program.EBuiltinFunction,
		QBasic.Program.Expressions.CExpression;

class CBuiltinFunctionExpressionNode : CFunctionExpressionNode
{
	public immutable EBuiltinFunction Function;

	public this(EBuiltinFunction aFunction)
	{
		Function = aFunction;
	}



	public override EExpressionNodeType NodeType()
	{
		return EExpressionNodeType.BuiltinFunction;
	}



	public override EPrimitiveType Type()
	{
		final switch (Function)
		{
			case EBuiltinFunction.Asc:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.Chr:
				return EPrimitiveType.String;
			case EBuiltinFunction.Command:
				return EPrimitiveType.String;
			case EBuiltinFunction.EOF:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.FreeFile:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.InKey:
				return EPrimitiveType.String;
			case EBuiltinFunction.Int:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.Len:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.LOF:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.LTrim:
				return EPrimitiveType.String;
			case EBuiltinFunction.Mid:
				return EPrimitiveType.String;
			case EBuiltinFunction.Rnd:
				return EPrimitiveType.Single;
			case EBuiltinFunction.RTrim:
				return EPrimitiveType.String;
			case EBuiltinFunction.Sgn:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.Space:
				return EPrimitiveType.String;
			case EBuiltinFunction.Str:
				return EPrimitiveType.String;
			case EBuiltinFunction.Val:
				return EPrimitiveType.Integer;
			case EBuiltinFunction.VarSeg:
				return EPrimitiveType.Reference;
		}
	}
}