﻿module QBasic.Parser.Expressions.CUnaryOperatorExpressionNode;
import std.typecons;
import QBasic.Parser.Expressions.CExpressionNode, QBasic.Program.CType, QBasic.Program.EOperator;

class CUnaryOperatorExpressionNode : CExpressionNode
{
	public immutable EUnaryOperator Operator;
	private Nullable!EPrimitiveType mType;

	public this(EUnaryOperator aOperator)
	{
		Operator = aOperator;
	}



	public override EExpressionNodeType NodeType()
	{
		return EExpressionNodeType.UnaryOperator;
	}



	public override EPrimitiveType Type()
	in
	{
		assert(Complete && !mType.isNull);
	}
	body
	{
		return mType;
	}



	public void SetType(EPrimitiveType aType)
	in
	{
		assert(!Complete && mType.isNull);
	}
	body
	{
		mType = aType;
	}
}