﻿module QBasic.Program.CProcedure;
import QBasic.Program.CIdentifier, QBasic.Program.CProcedureInfo, QBasic.Program.CVariableInfo,
		QBasic.Program.Instructions.IInstruction;

class CProcedure
{
	public const CIdentifier Name;
	private CProcedureInfo mInfo;
	private CVariableInfo[CIdentifier] mVariables;
	private CIdentifier[] mArgumentVariables;
	private IInstruction[] mInstructions;
	public immutable int StackSize;

	public this(CIdentifier aName, CProcedureInfo aInfo, CVariableInfo[CIdentifier] aVariables,
			CIdentifier[] aArgumentVariables, IInstruction[] aInstructions, int aStackSize)
	{
		Name = aName;
		mInfo = aInfo;
		mVariables = aVariables;
		mArgumentVariables = aArgumentVariables;
		mInstructions = aInstructions;
		StackSize = aStackSize;
	}



	public CProcedureInfo Info()
	{
		return mInfo;
	}



	public CVariableInfo[CIdentifier] Variables()
	{
		return mVariables;
	}



	public CIdentifier[] ArgumentVariables()
	{
		return mArgumentVariables;
	}



	public IInstruction[] Instructions()
	{
		return mInstructions;
	}
}