﻿module QBasic.Program.CProcedureInfo;
import QBasic.Program.CArgument, QBasic.Program.CType;

class CProcedureInfo
{
	private CType mReturnType;
	private CArgument[] mArguments;

	public this(CArgument[] aArguments)
	{
		mReturnType = null;
		mArguments = aArguments;
	}



	public this(CType aReturnType, CArgument[] aArguments)
	in
	{
		assert(aReturnType !is null);
	}
	body
	{
		mReturnType = aReturnType;
		mArguments = aArguments;
	}



	public CType ReturnType()
	{
		return mReturnType;
	}

	public const(CType) ReturnType() const
	{
		return mReturnType;
	}



	public CArgument[] Arguments()
	{
		return mArguments;
	}



	public bool ArgumentsMatch(CArgument[] aArguments)
	{
		if (Arguments.length != aArguments.length)
			return false;
		for (int i = 0; i < aArguments.length; i++)
		{
			if (!Arguments[i].Matches(aArguments[i]))
				return false;
		}
		return true;
	}
}