﻿module QBasic.Program.CProgram;
import QBasic.Program.CIdentifier, QBasic.Program.CProcedure, QBasic.Program.CProcedureInfo,
		QBasic.Program.CVariableInfo, QBasic.Program.Instructions.IInstruction;

class CProgram
{
	private CProcedure mMainProcedure;
	private CProcedure[CIdentifier] mProcedures;
	private CVariableInfo[CIdentifier] mSharedVariables;

	public CProcedure MainProcedure()
	in
	{
		assert(mMainProcedure !is null);
	}
	body
	{
		return mMainProcedure;
	}



	public CProcedure[CIdentifier] Procedures()
	{
		return mProcedures;
	}



	public CVariableInfo[CIdentifier] SharedVariables()
	{
		return mSharedVariables;
	}



	public void AddProcedure(CIdentifier aName, CProcedureInfo aInfo,
			CVariableInfo[CIdentifier] aVariables, CIdentifier[] aArgumentVariables,
			IInstruction[] aInstructions, int aStackSize)
	in
	{
		assert((aName is null && mMainProcedure is null) ||
				(aName !is null && aName !in mProcedures));
	}
	body
	{
		(aName is null ? mMainProcedure : mProcedures[aName]) = new CProcedure(aName, aInfo,
				aVariables, aArgumentVariables, aInstructions, aStackSize);
	}



	public void SetSharedVariables(CVariableInfo[CIdentifier] aSharedVariables)
	{
		mSharedVariables = aSharedVariables;
	}
}