﻿module QBasic.Program.Expressions.CExpression;
import QBasic.Program.CType, QBasic.Program.CValue, QBasic.Program.Expressions.Units;

class CExpression
{
	private CUnit[] mUnits;
	public immutable EPrimitiveType ResultType;

	public this(CUnit[] aUnits, EPrimitiveType aResultType)
	in
	{
		assert(aUnits.length != 0);
	}
	body
	{
		mUnits = aUnits;
		ResultType = aResultType;
	}



	public CUnit[] Units()
	{
		return mUnits;
	}



	/**
	Gets the value of the expression if it is a constant expression. Returns null if the
	expression is not a constant expression.
	*/
	public CValue Value()
	{
		if (mUnits.length != 1 || mUnits[0].UnitType != EUnitType.Value)
			return null;
		return mUnits[0].AsValue().Value;
	}
}