﻿module QBasic.Program.Expressions.CUnit;
import std.algorithm;
import QBasic.Program.Expressions.Units;

class CUnit
{
	public abstract EUnitType UnitType();



	public CBinaryOperatorUnit AsBinaryOperator()
	in
	{
		assert(UnitType == EUnitType.BinaryOperator);
	}
	body
	{
		return cast(CBinaryOperatorUnit)this;
	}



	public CBuiltinFunctionUnit AsBuiltinFunction()
	in
	{
		assert(UnitType == EUnitType.BuiltinFunction);
	}
	body
	{
		return cast(CBuiltinFunctionUnit)this;
	}



	public CFunctionUnit AsFunction()
	in
	{
		assert([ EUnitType.BuiltinFunction, EUnitType.UserFunction ].canFind(UnitType));
	}
	body
	{
		return cast(CFunctionUnit)this;
	}



	public CUnaryOperatorUnit AsUnaryOperator()
	in
	{
		assert(UnitType == EUnitType.UnaryOperator);
	}
	body
	{
		return cast(CUnaryOperatorUnit)this;
	}



	public CUserFunctionUnit AsUserFunction()
	in
	{
		assert(UnitType == EUnitType.UserFunction);
	}
	body
	{
		return cast(CUserFunctionUnit)this;
	}



	public CValueUnit AsValue()
	in
	{
		assert(UnitType == EUnitType.Value);
	}
	body
	{
		return cast(CValueUnit)this;
	}



	public CVariableUnit AsVariable()
	in
	{
		assert(UnitType == EUnitType.Variable);
	}
	body
	{
		return cast(CVariableUnit)this;
	}
}