﻿module QBasic.Program.Expressions.CVariableUnit;
import QBasic.Program.CName, QBasic.Program.CType, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Expressions.Units;

class CVariableUnit : CUnit
{
	private CName mName;
	private CType mType;
	private CType mTargetType;
	private CExpression[] mSubscripts;
	public immutable int RecordOffset;
	public immutable bool ArrayReference;
	public immutable bool Reference;

	public this(CName aName, CType aType, CType aTargetType, CExpression[] aSubscripts,
			int aRecordOffset, bool aArrayReference, bool aReference)
	in
	{
		assert(!aArrayReference || !aReference);
	}
	body
	{
		mName = aName;
		mType = aType;
		mTargetType = aTargetType;
		mSubscripts = aSubscripts;
		RecordOffset = aRecordOffset;
		ArrayReference = aArrayReference;
		Reference = aReference;
	}



	public override EUnitType UnitType()
	{
		return EUnitType.Variable;
	}



	public CName Name()
	{
		return mName;
	}



	public CType Type()
	{
		return mType;
	}



	public CType TargetType()
	{
		return mTargetType;
	}



	public CExpression[] Subscripts()
	{
		return mSubscripts;
	}
}