﻿module QBasic.Program.Instructions.CAssignmentInstruction;
import QBasic.Interpreter.Instructions.CAssignmentInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CAssignmentInstruction : CInstruction
{
	private CExpression mTargetExpression;
	private CExpression mExpression;
	public immutable bool BinaryCopy;

	public this(CExpression aTargetExpression, CExpression aExpression, bool aBinaryCopy)
	in
	{
		assert(aTargetExpression !is null && aExpression !is null);
	}
	body
	{
		mTargetExpression = aTargetExpression;
		mExpression = aExpression;
		BinaryCopy = aBinaryCopy;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CAssignmentInterpreter();
	}



	public CExpression TargetExpression()
	{
		return mTargetExpression;
	}



	public CExpression Expression()
	{
		return mExpression;
	}
}