﻿module QBasic.Program.Instructions.CBranchInstruction;
import QBasic.Interpreter.Instructions.CBranchInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction,
		QBasic.Program.Instructions.IBranchInstruction;

class CBranchInstruction : CInstruction, IBranchInstruction
{
	private int mNextInstruction = -1;



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CBranchInterpreter();
	}



	public int GetNextInstruction()
	in
	{
		assert(mNextInstruction != -1);
	}
	body
	{
		return mNextInstruction;
	}



	public void SetNextInstruction(int aNextInstruction)
	in
	{
		assert(aNextInstruction >= 0);
	}
	body
	{
		mNextInstruction = aNextInstruction;
	}
}