module QBasic.Program.Instructions.CExtensionCommandInstruction;
import QBasic.Interpreter.Instructions.CExtensionCommandInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.EExtensionCommand,
		QBasic.Program.Instructions.CInstruction;

class CExtensionCommandInstruction : CInstruction
{
	public immutable EExtensionCommand Command;
	private CExpression[] mArguments;

	public this(EExtensionCommand aCommand, CExpression[] aArguments)
	{
		Command = aCommand;
		mArguments = aArguments;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CExtensionCommandInterpreter();
	}



	public CExpression[] Arguments()
	{
		return mArguments;
	}
}