﻿module QBasic.Program.Instructions.CFileGetInstruction;
import QBasic.Interpreter.Instructions.CFileGetInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CFileGetInstruction : CInstruction
{
	private CExpression mFileNumberExpression;
	private CExpression mTargetExpression;

	public this(CExpression aFileNumberExpression, CExpression aTargetExpression)
	{
		mFileNumberExpression = aFileNumberExpression;
		mTargetExpression = aTargetExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CFileGetInterpreter();
	}



	public CExpression FileNumberExpression()
	{
		return mFileNumberExpression;
	}



	public CExpression TargetExpression()
	{
		return mTargetExpression;
	}
}