﻿module QBasic.Program.Instructions.CFileOpenInstruction;
import QBasic.Interpreter.Instructions.CFileOpenInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.EFileOpenMode, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Instructions.CInstruction;

class CFileOpenInstruction : CInstruction
{
	private CExpression mPathExpression;
	private EFileOpenMode mMode;
	private CExpression mNumberExpression;

	public this(CExpression aPathExpression, EFileOpenMode aMode, CExpression aNumberExpression)
	{
		mPathExpression = aPathExpression;
		mMode = aMode;
		mNumberExpression = aNumberExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CFileOpenInterpreter();
	}



	public CExpression PathExpression()
	{
		return mPathExpression;
	}



	public EFileOpenMode Mode()
	{
		return mMode;
	}



	public CExpression NumberExpression()
	{
		return mNumberExpression;
	}
}