﻿module QBasic.Program.Instructions.CFilePutInstruction;
import QBasic.Interpreter.Instructions.CFilePutInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CFilePutInstruction : CInstruction
{
	private CExpression mFileNumberExpression;
	private CExpression mSourceExpression;

	public this(CExpression aFileNumberExpression, CExpression aSourceExpression)
	{
		mFileNumberExpression = aFileNumberExpression;
		mSourceExpression = aSourceExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CFilePutInterpreter();
	}



	public CExpression FileNumberExpression()
	{
		return mFileNumberExpression;
	}



	public CExpression SourceExpression()
	{
		return mSourceExpression;
	}
}