﻿module QBasic.Program.Instructions.CFileSeekInstruction;
import QBasic.Interpreter.Instructions.CFileSeekInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CFileSeekInstruction : CInstruction
{
	private CExpression mNumberExpression;
	private CExpression mPositionExpression;

	public this(CExpression aNumberExpression, CExpression aPositionExpression)
	{
		mNumberExpression = aNumberExpression;
		mPositionExpression = aPositionExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CFileSeekInterpreter();
	}



	public CExpression NumberExpression()
	{
		return mNumberExpression;
	}



	public CExpression PositionExpression()
	{
		return mPositionExpression;
	}
}