﻿module QBasic.Program.Instructions.CForInitInstruction;
import QBasic.Interpreter.Instructions.CForInitInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CName, QBasic.Program.Expressions.CExpression,
		 QBasic.Program.Instructions.CInstruction;

class CForInitInstruction : CInstruction
{
	private int mStackOffset;
	private CExpression mTargetExpression;
	private CExpression mStartExpression;
	private CExpression mEndExpression;
	private CExpression mStepExpression;

	public this(int aStackOffset, CExpression aTargetExpression, CExpression aStartExpression,
			CExpression aEndExpression, CExpression aStepExpression)
	{
		mStackOffset = aStackOffset;
		mTargetExpression = aTargetExpression;
		mStartExpression = aStartExpression;
		mEndExpression = aEndExpression;
		mStepExpression = aStepExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CForInitInterpreter();
	}



	public int GetStackOffset()
	{
		return mStackOffset;
	}



	public CExpression TargetExpression()
	{
		return mTargetExpression;
	}



	public CExpression GetStartExpression()
	{
		return mStartExpression;
	}



	public CExpression GetEndExpression()
	{
		return mEndExpression;
	}



	public CExpression GetStepExpression()
	{
		return mStepExpression;
	}
}