﻿module QBasic.Program.Instructions.CForInstruction;
import QBasic.Interpreter.Instructions.CForInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CInstruction;

class CForInstruction : CInstruction
{
	private int mStackOffset;
	private int mNextInstruction;

	public this(int aStackOffset)
	{
		mStackOffset = aStackOffset;
		mNextInstruction = -1;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CForInterpreter();
	}



	public int GetStackOffset()
	{
		return mStackOffset;
	}



	public int GetNextInstruction()
	in
	{
		assert(mNextInstruction != -1);
	}
	body
	{
		return mNextInstruction;
	}



	public void SetNextInstruction(int aNextInstruction)
	in
	{
		assert(aNextInstruction >= 0);
	}
	body
	{
		mNextInstruction = aNextInstruction;
	}
}