﻿module QBasic.Program.Instructions.CForNextInstruction;
import QBasic.Interpreter.Instructions.CForNextInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CInstruction;

class CForNextInstruction : CInstruction
{
	private int mStackOffset;
	private int mStartInstruction;

	public this(int aStackOffset, int aStartInstruction)
	in
	{
		assert(aStartInstruction >= 0);
	}
	body
	{
		mStackOffset = aStackOffset;
		mStartInstruction = aStartInstruction;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CForNextInterpreter();
	}



	public int GetStackOffset()
	{
		return mStackOffset;
	}



	public int GetStartInstruction()
	{
		return mStartInstruction;
	}
}