﻿module QBasic.Program.Instructions.CGraphicsLineInstruction;
import QBasic.Interpreter.Instructions.CGraphicsLineInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.ELineType, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Instructions.CInstruction;

class CGraphicsLineInstruction : CInstruction
{
	private CExpression mX0Expression;
	private CExpression mY0Expression;
	private CExpression mX1Expression;
	private CExpression mY1Expression;
	private CExpression mColourExpression;
	public immutable ELineType Type;

	public this(CExpression aX0Expression, CExpression aY0Expression,
			CExpression aX1Expression, CExpression aY1Expression,
			CExpression aColourExpression, ELineType aType)
	{
		mX0Expression = aX0Expression;
		mY0Expression = aY0Expression;
		mX1Expression = aX1Expression;
		mY1Expression = aY1Expression;
		mColourExpression = aColourExpression;
		Type = aType;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CGraphicsLineInterpreter();
	}



	public CExpression X0Expression()
	{
		return mX0Expression;
	}



	public CExpression Y0Expression()
	{
		return mY0Expression;
	}



	public CExpression X1Expression()
	{
		return mX1Expression;
	}



	public CExpression Y1Expression()
	{
		return mY1Expression;
	}



	public CExpression ColourExpression()
	{
		return mColourExpression;
	}
}