﻿module QBasic.Program.Instructions.CGraphicsPutInstruction;
import QBasic.Interpreter.Instructions.CGraphicsPutInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.EGraphicsOperation, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Instructions.CInstruction;

class CGraphicsPutInstruction : CInstruction
{
	private CExpression mXExpression;
	private CExpression mYExpression;
	private CExpression mImageExpression;
	private EGraphicsOperation mOperation;

	public this(CExpression aXExpression, CExpression aYExpression,
			CExpression aImageExpression, EGraphicsOperation aOperation)
	{
		mXExpression = aXExpression;
		mYExpression = aYExpression;
		mImageExpression = aImageExpression;
		mOperation = aOperation;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CGraphicsPutInterpreter();
	}



	public CExpression XExpression()
	{
		return mXExpression;
	}



	public CExpression YExpression()
	{
		return mYExpression;
	}



	public CExpression ImageExpression()
	{
		return mImageExpression;
	}



	public EGraphicsOperation Operation()
	{
		return mOperation;
	}
}