﻿module QBasic.Program.Instructions.CIfInstruction;
import QBasic.Interpreter.Instructions.CIfInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.IBranchInstruction,
		QBasic.Program.Instructions.CInstruction;

class CIfInstruction : CInstruction, IBranchInstruction
{
	private CExpression mConditionExpression;
	private int mNextInstruction = -1;

	public this(CExpression aConditionExpression)
	{
		mConditionExpression = aConditionExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CIfInterpreter();
	}



	public CExpression GetConditionExpression()
	{
		return mConditionExpression;
	}



	public int GetNextInstruction()
	in
	{
		assert(mNextInstruction != -1);
	}
	body
	{
		return mNextInstruction;
	}



	public void SetNextInstruction(int aNextInstruction)
	in
	{
		assert(aNextInstruction >= 0);
	}
	body
	{
		mNextInstruction = aNextInstruction;
	}
}