﻿module QBasic.Program.Instructions.CLoopStartInstruction;
import QBasic.Interpreter.Instructions.CLoopStartInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CLoopStartInstruction : CInstruction
{
	private bool mUntil;
	private CExpression mExpression;
	private int mNextInstruction;

	public this(bool aUntil, CExpression aExpression, int aNextInstruction = -1)
	in
	{
		assert(aNextInstruction >= -1);
	}
	body
	{
		mUntil = aUntil;
		mExpression = aExpression;
		mNextInstruction = aNextInstruction;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CLoopStartInterpreter();
	}



	public bool GetUntil()
	{
		return mUntil;
	}



	public CExpression GetExpression()
	{
		return mExpression;
	}



	public int GetNextInstruction()
	in
	{
		assert(mNextInstruction != -1);
	}
	body
	{
		return mNextInstruction;
	}



	public void SetNextInstruction(int aNextInstruction)
	in
	{
		assert(mNextInstruction == -1 && aNextInstruction >= 0);
	}
	body
	{
		mNextInstruction = aNextInstruction;
	}
}