﻿module QBasic.Program.Instructions.CMidInstruction;
import QBasic.Interpreter.Instructions.CMidInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CMidInstruction : CInstruction
{
	private CExpression mTargetExpression;
	private CExpression mStartExpression;
	private CExpression mExpression;

	public this(CExpression aTargetExpression, CExpression aStartExpression,
			CExpression aExpression)
	{
		mTargetExpression = aTargetExpression;
		mStartExpression = aStartExpression;
		mExpression = aExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CMidInterpreter();
	}



	public CExpression TargetExpression()
	{
		return mTargetExpression;
	}



	public CExpression StartExpression()
	{
		return mStartExpression;
	}



	public CExpression Expression()
	{
		return mExpression;
	}
}