﻿module QBasic.Program.Instructions.COutInstruction;
import QBasic.Interpreter.Instructions.COutInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class COutInstruction : CInstruction
{
	private CExpression mPortExpression;
	private CExpression mDataExpression;

	public this(CExpression aPortExpression, CExpression aDataExpression)
	{
		mPortExpression = aPortExpression;
		mDataExpression = aDataExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new COutInterpreter();
	}



	public CExpression PortExpression()
	{
		return mPortExpression;
	}



	public CExpression DataExpression()
	{
		return mDataExpression;
	}
}