﻿module QBasic.Program.Instructions.CSelectCase;
import QBasic.Program.Expressions.CExpression;

enum ECaseType { Normal, Range, Is }

enum ECaseIsOperator { Less, LessOrEqual, Greater, GreaterOrEqual, Equal, NotEqual };

class CSelectCase
{
	private ECaseType mType;
	private CExpression mExpression;
	private CExpression mEndExpression;
	private ECaseIsOperator mOperator;

	public this(CExpression aExpression)
	{
		mType = ECaseType.Normal;
		mExpression = aExpression;
	}



	public this(CExpression aExpression, CExpression aEndExpression)
	{
		mType = ECaseType.Range;
		mExpression = aExpression;
		mEndExpression = aEndExpression;
	}



	public this(ECaseIsOperator aOperator, CExpression aExpression)
	{
		mType = ECaseType.Is;
		mExpression = aExpression;
		mOperator = aOperator;
	}



	public ECaseType GetType()
	{
		return mType;
	}



	public CExpression GetExpression()
	{
		return mExpression;
	}



	public CExpression GetEndExpression()
	in
	{
		assert(mType == ECaseType.Range);
	}
	body
	{
		return mEndExpression;
	}



	public ECaseIsOperator GetOperator()
	in
	{
		assert(mType == ECaseType.Is);
	}
	body
	{
		return mOperator;
	}
}