﻿module QBasic.Program.Instructions.CSelectCaseInstruction;
import QBasic.Interpreter.Instructions.CSelectCaseInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Instructions.CSelectCase, QBasic.Program.Instructions.IBranchInstruction,
		QBasic.Program.Instructions.CInstruction;

class CSelectCaseInstruction : CInstruction, IBranchInstruction
{
	public immutable int StackOffset;
	private CSelectCase[] mCases;
	private int mNextInstruction = -1;

	public this(int aStackOffset, CSelectCase[] aCases)
	{
		StackOffset = aStackOffset;
		mCases = aCases;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CSelectCaseInterpreter();
	}



	public CSelectCase[] GetCases()
	{
		return mCases;
	}



	public int GetNextInstruction()
	in
	{
		assert(mNextInstruction != -1);
	}
	body
	{
		return mNextInstruction;
	}



	public void SetNextInstruction(int aNextInstruction)
	in
	{
		assert(aNextInstruction >= 0);
	}
	body
	{
		mNextInstruction = aNextInstruction;
	}
}