﻿module QBasic.Program.Instructions.CSelectInstruction;
import QBasic.Interpreter.Instructions.CSelectInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.Expressions.CExpression, QBasic.Program.Instructions.CInstruction;

class CSelectInstruction : CInstruction
{
	private int mStackOffset;
	private CExpression mExpression;

	public this(int aStackOffset, CExpression aExpression)
	{
		mStackOffset = aStackOffset;
		mExpression = aExpression;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CSelectInterpreter();
	}



	public int GetStackOffset()
	{
		return mStackOffset;
	}



	public CExpression GetExpression()
	{
		return mExpression;
	}
}