﻿module QBasic.Program.Instructions.CSubCallInstruction;
import QBasic.Interpreter.Instructions.CSubCallInterpreter, QBasic.Interpreter.Instructions.IInstructionInterpreter,
		QBasic.Program.CIdentifier, QBasic.Program.Expressions.CExpression,
		QBasic.Program.Instructions.CInstruction;

class CSubCallInstruction : CInstruction
{
	private CIdentifier mSubName;
	private CExpression[] mArguments;

	public this(CIdentifier aSubName, CExpression[] aArguments)
	{
		mSubName = aSubName;
		mArguments = aArguments;
	}



	public IInstructionInterpreter CreateInterpreter()
	{
		return new CSubCallInterpreter();
	}



	public CIdentifier GetSubName()
	{
		return mSubName;
	}



	public CExpression[] GetArguments()
	{
		return mArguments;
	}
}