﻿module Core.CColour;

class CColour
{
	public float R;
	public float G;
	public float B;

	public this()
	{
		R = 0;
		G = 0;
		B = 0;
	}



	public this(float aR, float aG, float aB)
	in
	{
		assert(aR >= 0 && aR <= 1 && aG >= 0 && aG <= 1 && aB >= 0 && aB <= 1);
	}
	body
	{
		R = aR;
		G = aG;
		B = aB;
	}



	public this(int aColour)
	in
	{
		assert(aColour >= 0 && aColour <= 0xffffff);
	}
	body
	{
		R = cast(float)((aColour >> 16) & 0xff) / 255;
		G = cast(float)((aColour >> 8) & 0xff) / 255;
		B = cast(float)(aColour & 0xff) / 255;
	}



	public override bool opEquals(Object o)
	{
		auto Colour = cast(CColour)o;
		return R == Colour.R && G == Colour.G && B == Colour.B;
	}



	public uint Int()
	{
		return cast(uint)(R * 255) | (cast(uint)(G * 255) << 8) | (cast(uint)(B * 255) << 16);
	}
}