﻿module Tractor.Controller;
import Tractor.Tractor;

interface IController
{
	CControllerOptions GetOptions();
	void Initialise(ITractor aTractor);
	void OnFrame();
	void OnKeyDown(EKey aKey);
	void OnKeyUp(EKey aKey);
}



class CControllerOptions
{
	public immutable int DisplayXSize;
	public immutable int DisplayYSize;
	public immutable string LocalDirectoryName;

	public this(int aDisplayXSize, int aDisplayYSize, string aLocalDirectoryName = null)
	{
		DisplayXSize = aDisplayXSize;
		DisplayYSize = aDisplayYSize;
		LocalDirectoryName = aLocalDirectoryName.idup;
	}
}