﻿module Tractor.Shaders;
import Shaders.EBuiltinShader;

interface IShaderModule
{
	IVertexShader LoadBuiltinVertexShader(EBuiltinShader aShader);
	IFragmentShader LoadBuiltinFragmentShader(EBuiltinShader aShader);
	IVertexShader LoadCustomVertexShader(string aFileName);
	IFragmentShader LoadCustomFragmentShader(string aFileName);
	uint CreateBuiltinProgram(EBuiltinShader aShader);
	IShaderProgram CreateCustomProgram(IVertexShader aVertexShader,
			IFragmentShader aFragmentShader);
	void UseBuiltinProgram(EBuiltinShader aProgram);
	void UseCustomProgram(IShaderProgram aProgram);
}



interface IShader
{
	uint ID();
}



interface IVertexShader : IShader
{
}



interface IFragmentShader : IShader
{
}



interface IShaderProgram
{
	uint ID();
	void BindAttribute(int aIndex, string aName);
	void Link();
}